unit uTrajectoires;

// RECONNAISSANCE DE TRAJECTOIRES monochromes paisses d'un seul pixel traces
// sur un BitMap.
// La vitesse d'excution rsulte ici principalement de l'utilisation d'une Mire
//  9 cases qui suit la trajectoire  la trace ce qui limite le balayage du BitMap
//  une zone large de 3 pixels et de longueur gale  celle de la trajectoire.

// Version lgrement modifie par Charly910 le 17/04/2018 :
//    Trajectoire stocke dans Memo1 et affiche dans Trajectoire.txt

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, ComCtrls, Menus, Math;

Type

   TTraj     = array of TPoint; //< RESULTATS de la numrisation de la trajectpoire


type
  TF_Contour = class(TForm)
    Image1: TImage;
    labCoor: TLabel;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    btnChargerBMP: TSpeedButton;
    labInfos: TLabel;
    plMire: TPanel;
    plSO: TPanel;
    plNO: TPanel;
    plO: TPanel;
    plN: TPanel;
    plMi: TPanel;
    plS: TPanel;
    plNE: TPanel;
    plE: TPanel;
    plSE: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    editX: TEdit;
    editY: TEdit;
    plTraject: TPanel;
    labNBPoints: TLabel;
    labXE1: TLabel;
    labYE1: TLabel;
    labXE2: TLabel;
    labYE2: TLabel;
    btnExemples: TSpeedButton;
    btnCas: TSpeedButton;
    labChrono: TLabel;
    Label4: TLabel;
    PanelRalenti: TPanel;
    Label5: TLabel;
    CheckBoxRalenti: TCheckBox;
    UpDownRalenti: TUpDown;
    EditRalenti: TEdit;
    PopupCasLimites: TPopupMenu;
    PointesDAngles: TMenuItem;
    Croisements: TMenuItem;
    Memo1: TMemo;
    BtnSauve: TSpeedButton;
    Panel2: TPanel;
    BtnQuitter: TButton;
    Label6: TLabel;
    LblPoint0: TLabel;
    LblPointN: TLabel;
    LblPerimetre: TLabel;
    LblSurface: TLabel;
    ChkTest: TCheckBox;
    Btn_Gomme: TSpeedButton;
    Label7: TLabel;
    procedure btnChargerBMPClick(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure editXKeyPress(Sender: TObject; var Key: Char);
    procedure editXChange(Sender: TObject);
    procedure editYChange(Sender: TObject);
    procedure btnExemplesClick(Sender: TObject);
    procedure EcranNoir;
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBoxRalentiClick(Sender: TObject);
    procedure PointesDAnglesClick(Sender: TObject);
    procedure CroisementsClick(Sender: TObject);
    procedure btnCasClick(Sender: TObject);
    procedure BtnSauveClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    Function  LanceNotePad(Fichier : String): dword;
    Function  FermeNotePad(ImpID : dWord ) : Boolean ;
    Procedure Surface(Var kDeb : Integer ; Var Surf : Extended);
    Procedure Perimetre2(kDeb : Integer ; Var Perim : Extended);
    procedure BtnQuitterClick(Sender: TObject);
    Procedure RazLabel ;
    procedure ChkTestClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Btn_GommeClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
    function GetThreadId(Thread: THandle): dword; stdcall; external 'Kernel32.dll';

var
  F_Contour : TF_Contour ;
  Traj  : TTraj ;     // RESULTATS de la numrisation
  LTraj : Integer ;   // Nombre de points de la trajectoire
  ImpID : dWord   ;   // Handle de NotePad
  Kdeb  : Integer ;   // dbut du vrai contour dans les cas compliqus
  Surf  : Extended  ;   // Surface du contour
  Perim : Extended  ;   // Primtre du contour
  Test  : Boolean ;   // Affichage intermdiaire si vrai
  Painting : Boolean ;  // Dessin en cours
  Gomme    : Boolean ;  // Mode gomme
  
implementation
{$R *.DFM}
const     crlf = #13#10;
{ =========================================================================== }
procedure SMS(s : string);
  begin
    If Test Then ShowMessage(s);
  end;
{ =========================================================================== }

type      TMire     = record                           // 001    NO N NE
                       M : array[-1..1,-1..1] of byte; // 010     O * E
                       S : byte;                       // 100    SO S SE
                      end; // S = nombre de points "jaunes" dans la Mire
          TMireCl   = array[-1..1,-1..1] of TColor;
          TPasVers  = (Station,Nord,NordOuest,Ouest,SudOuest,Sud,SudEst,Est,NordEst);

var       Mire    : TMire;         // Mire principale
//          MA      : TMire;         // Mire d''appoint
          MireCl  : TMireCl;       // Mire couleurs
          TCount   : Integer;       // Nombre de points sur la trajectoire
          clTraj1 : TColor;        // Couleur d'identification de la trajectoire <> du Noir
          clTraj2 : TColor;        // Couleur du trac de contrle <> du Noir
          BMPSource : tBitMap;     // BitMap avec trajectoire  numriser
          xExt1,yExt1   : integer; // Coordonnes 1re extrmit de la trajectoire
          xExt2,yExt2   : integer; // Coordonnes 2me extrmit de la trajectoire
          DP        : TPasVers;    // Dernier pas
          PS        : TPasVers;    // Pas suivant
          ADP       : TPasVers;    // Avant-Dernier-Pas
          RecoEnCours : boolean;

const     MaxPixelCount   = 50001; //< augmenter si besoin est

type      ppRGBArray  =  ^tTRGBArray;
          tTRGBArray  =  ARRAY[0..MaxPixelCount-1] OF TRGBTriple;
{ =========================================================================== }
function  LisScanlinePixel(bmp : TBitMap; x,y : integer) : TColor;
var       Ligne : ppRGBArray;
begin     with bmp do
            begin if (x>=0) and (y>=0) and (x<=width-1) and (y<=height-1) then
                begin Ligne := ScanLine[Y];
                      with Ligne[X] do Result:=RGB(rgbtRed,rgbtGreen,rgbtBlue);
                end else Result:=-1;
            end;
end; // LisScanlinePixel
{ =========================================================================== }
function  LisScanlinePixelB(bmp : TBitMap; x,y : integer) : byte;
var       cl : TColor;
begin     cl:=LisScanlinePixel(bmp,x,y);
          if cl=clTraj1 then Result:=1 else Result:=0;
end; // LisScanlinePixel2
{ =========================================================================== }
function  LisScanlinesVersMire(bmp : TBitMap; xc,yc : integer) : TMire;
var       Ligne : ppRGBArray;
          co,li,h,w : integer;
          cl    : TColor;
begin     for co:=-1 to 1 do for li:=-1 to 1 do Result.M[co,li]:=0;
          Result.S:=0;
          with bmp do
          begin h:=bmp.height; w:=bmp.width;
                for li:=-1 to 1 do
                begin if (yc+li>=0) and (yc+li<=h-1) then
                      begin Ligne := ScanLine[yc+li];
                            for co:=-1 to 1 do
                            begin if (xc+co>=0) and (xc+co<=w-1) then
                                  begin with Ligne[xc+co] do
                                        begin cl:=RGB(rgbtRed,rgbtGreen,rgbtBlue);
                                              if cl=clTraj1 then
                                              begin Result.M[co,li]:=1;
                                                    inc(Result.S);
                                              end;
                                        end;
                                  end; //if (xc
                            end; // for co
                      end; // if (yc
                end; // for li
          end; // with bmp
end; // LisScanlinesVersMire
{ =========================================================================== }
function  LisPixelsVersMire(bmp : TBitMap; xc,yc : integer) : TMire;
//        Non utilise ici
//        Pour reco de trajectoire avec des bmp de pf4bits (16 couleurs)
var       co,li,h,w : integer;
          cl    : TColor;
begin     for co:=-1 to 1 do for li:=-1 to 1 do Result.M[co,li]:=0;
          Result.S:=0;
          with bmp do
          begin h:=bmp.height; w:=bmp.width;
                for li:=-1 to 1 do
                begin if (yc+li>=0) and (yc+li<=h-1) then
                      begin for co:=-1 to 1 do
                            begin if (xc+co>=0) and (xc+co<=w-1) then
                                  begin cl:=bmp.canvas.Pixels[xc+co,yc+li];
                                        if cl=clTraj1 then
                                        begin Result.M[co,li]:=1;
                                              inc(Result.S);
                                        end;
                                  end; //if (xc
                            end; // for co
                      end; // if (yc
                end; // for li
          end; // with bmp
end; // LisPixelsVersMire
{ =========================================================================== }
function  LisScanlinesVersMireCL(bmp : TBitMap; xc,yc : integer) : TMireCL;
//        Pour pipette
var       Ligne : ppRGBArray;
          co,li,h,w : integer;
begin     for co:=-1 to 1 do for li:=-1 to 1 do Result[co,li]:=clBlack;
          with bmp do
          begin h:=bmp.height; w:=bmp.width;
                for li:=-1 to 1 do
                begin if (yc+li>=0) and (yc+li<=h-1) then
                      begin Ligne := ScanLine[yc+li];
                            for co:=-1 to 1 do
                            begin if (xc+co>=0) and (xc+co<=w-1) then
                                  begin with Ligne[xc+co]
                                          do Result[co,li]:=RGB(rgbtRed,rgbtGreen,rgbtBlue);
                                  end; //if (xc
                            end; // for co
                      end; // if (yc
                end; // for li
          end; // with bmp
end; // LisScanlinesVersMireCl
{ =========================================================================== }
procedure AffMire(M : TMire; x,y : integer);
begin     sms(  'x='+intToStr(x)+crlf+
                'y='+intToStr(y)+crlf+
                intToStr(M.M[-1,-1])+intToStr(M.M[0,-1])+intToStr(M.M[1,-1])+crlf+
                intToStr(M.M[-1, 0])+intToStr(M.M[0, 0])+intToStr(M.M[1, 0])+crlf+
                intToStr(M.M[-1,+1])+intToStr(M.M[0,+1])+intToStr(M.M[1,+1])+crlf+
                'S='+intToStr(M.S));
end;
{ =========================================================================== }
procedure ActuMireEcran(X,Y : integer);
var       Mc : TMireCL;
begin     with F_Contour do
          begin Mc:=LisScanlinesVersMireCL(F_Contour.Image1.Picture.Bitmap, X,Y);
                plNO.color:=Mc[-1,-1]; plN.color :=Mc[0,-1]; plNE.color:=Mc[1,-1];
                 plO.color:=Mc[-1, 0]; plMi.color:=Mc[0, 0]; plE.color :=Mc[1, 0];
                plSO.color:=Mc[-1,+1]; plS.color :=Mc[0,+1]; plSE.color:=Mc[1,+1];
          end;
end;
{ =========================================================================== }
procedure ActuMireEtCooEcran(X,Y : integer);
begin     with F_Contour do
          begin editX.text:=intToStr(x);
                editY.text:=intToStr(y);
                ActuMireEcran(x,y);
          end;
end;
{ =========================================================================== }
procedure CacheMire;
begin     with F_Contour do
          begin editX.text:='';
                editY.text:='';
                ActuMireEcran(0,0);
          end;
end;
{ =========================================================================== }
procedure AffInfos(s : string);
begin     F_Contour.labInfos.caption:=s; F_Contour.labInfos.Update; //sleep(80);
end;
{ =========================================================================== }
procedure MetsScanlinePixel(var bmp : TBitMap; x,y : integer; Coul : TColor);
//        Pour trac de contrle
var       Ligne : ppRGBArray;
begin     with bmp do
          begin //PixelFormat:=pf24bit; < fait ds le chargement du Bmp
                if (x>=0) and (y>=0) and (x<=width-1) and (y<=height-1) then
                begin Ligne := ScanLine[y];
                      with Ligne[x] do
                      begin rgbtRed  := GetRValue(Coul);
                            rgbtGreen:= GetGValue(Coul);
                            rgbtBlue := GetBValue(Coul);
                      end;
                end;
          end;
end; // MetsScanlinePixel
{ =========================================================================== }
function  PasToStr( Direction : TPasVers) : string;
begin     Result:='';
          case Direction Of
               Station       : Result:='Station';
               Nord      : Result:='Nord';
               NordOuest : Result:='NordOuest';
               Ouest     : Result:='Ouest';
               SudOuest  : Result:='SudOuest';
               Sud       : Result:='Sud';
               SudEst    : Result:='SudEst';
               Est       : Result:='Est';
               NordEst   : Result:='NordEst';
           end;
end;
{ =========================================================================== }
procedure AllerEn( var Direction : TPasVers; var x,y : integer);
begin     case Direction Of
               Nord      : dec(y);
               NordOuest : begin dec(y); dec(x); end;
               Ouest     : dec(x);
               SudOuest  : begin dec(x); inc(y); end;
               Sud       : inc(y);
               SudEst    : begin inc(y); inc(x); end;
               Est       : begin inc(x);  end;
               NordEst   : begin inc(x); dec(y); end;
           end;
           DP:=Direction;
end;
{ =========================================================================== }
function  DirInverse( Direction : TPasVers) : TPasVers;
begin     Result:=Station;
          case Direction Of
               Nord      : Result:=Sud;
               NordOuest : Result:=SudEst;
               Ouest     : Result:=Est;
               SudOuest  : Result:=NordEst;
               Sud       : Result:=Nord;
               SudEst    : Result:=NordOuest;
               Est       : Result:=Ouest;
               NordEst   : Result:=SudOuest;
           end;
end;
{ =========================================================================== }
function  RienAuNord(bmp : tBitMap; xct,yct : integer) : boolean;
//        Utilise mire d''appoint pour vrifier s''il n''y a aucun pixel "jaune"
//        au Nord de la mire principale centre sur xct,yct
var       M : TMire;
begin     M:=LisScanlinesVersMire(bmp,xct,yct-1);
          if (M.M[-1,-1]=0) and (M.M[0,-1]=0) and (M.M[1,-1]=0)
          then Result:=true else Result:=false;
end;
{ =========================================================================== }
function  RienAlOuest(bmp : tBitMap; xct,yct : integer) : boolean;
var       M : TMire;
begin     M:=LisScanlinesVersMire(bmp,xct-1,yct);
          if (M.M[-1,-1]=0) and (M.M[-1,0]=0) and (M.M[-1,1]=0)
          then Result:=true else Result:=false;
end;
{ =========================================================================== }
function  RienAuSud(bmp : tBitMap; xct,yct : integer) : boolean;
var       M : TMire;
begin     M:=LisScanlinesVersMire(bmp,xct,yct+1);
          if (M.M[-1,1]=0) and (M.M[0,1]=0) and (M.M[1,1]=0)
          then Result:=true else Result:=false;
end;
{ =========================================================================== }
function  RienAlEst(bmp : tBitMap; xct,yct : integer) : boolean;
var       M : TMire;
begin     M:=LisScanlinesVersMire(bmp,xct+1,yct);
          if (M.M[1,1]=0) and (M.M[1,0]=0) and (M.M[1,-1]=0)
          then Result:=true else Result:=false;
end;
{ =========================================================================== }
function  RienAuNordOuest(bmp : tBitMap; xct,yct : integer) : boolean;
var       M : TMire;
begin     M:=LisScanlinesVersMire(bmp,xct-1,yct-1);
          if (M.M[1,-1]=0) and (M.M[0,-1]=0) and (M.M[-1,-1]=0)
          and (M.M[-1,0]=0) and (M.M[-1,1]=0)
          then Result:=true else Result:=false;
end;
{ =========================================================================== }
function  RienAuSudOuest(bmp : tBitMap; xct,yct : integer) : boolean;
var       M : TMire;
begin     M:=LisScanlinesVersMire(bmp,xct-1,yct+1);
          if (M.M[-1,-1]=0) and (M.M[-1,0]=0) and (M.M[-1,1]=0)
          and (M.M[0,1]=0) and (M.M[1,1]=0)
          then Result:=true else Result:=false;
end;
{ =========================================================================== }
function  RienAuSudEst(bmp : tBitMap; xct,yct : integer) : boolean;
var       M : TMire;
begin     M:=LisScanlinesVersMire(bmp,xct+1,yct+1);
          if (M.M[-1,1]=0) and (M.M[0,1]=0) and (M.M[1,1]=0)
          and (M.M[1,0]=0) and (M.M[1,-1]=0)
          then Result:=true else Result:=false;
end;
{ =========================================================================== }
function  RienAuNordEst(bmp : tBitMap; xct,yct : integer) : boolean;
var       M : TMire;
begin     M:=LisScanlinesVersMire(bmp,xct+1,yct-1);
          if (M.M[1,1]=0) and (M.M[1,0]=0) and (M.M[1,-1]=0)
          and (M.M[0,-1]=0) and (M.M[-1,-1]=0)
          then Result:=true else Result:=false;
end;
{ =========================================================================== }
procedure SauverPointTraj(x,y : integer; var ind : integer);
var       Taille : integer;
begin
          inc(ind);
          Taille := Length(Traj);
          if ind>=Taille then SetLength(Traj,Taille+1000);
          Traj[ind].x:=x; Traj[ind].y:=y;
          F_Contour.Memo1.lines.add(IntToStr(LTraj)+ '  '+IntToStr(x)+'  '+IntToStr(y)) ;
          LTraj := LTraj + 1 ;
end;
{ =========================================================================== }
function  CUnePointue( Direction,InclineVers : TPasVers; bmp : tBitMap;
                       xct,yct : integer; var P1,P2 : TPoint) : boolean;
var       M : TMire; x,y : integer;
begin     Result:=False; P1.x:=-1; P1.y:=-1; P2.x:=-1; P2.y:=-1;
          if Direction=Ouest then
          begin x:=xct; y:=yct;
                while (x>0) and (LisScanlinePixelB(bmp,x,y)=1) do dec(x);
                inc(x);
                M:=LisScanlinesVersMire(bmp,x,y);
                if (M.S=5)
                and ( ((M.M[-1,1]=1)  and (M.M[0,1]=1)  and (M.M[1,0]=1)  and (M.M[1,1]=1))
                   or ((M.M[-1,-1]=1) and (M.M[0,-1]=1) and (M.M[1,-1]=1) and (M.M[1,0]=1))) then
                begin P1.x:=x; P1.y:=y;
                      case InclineVers of
                           Nord : begin inc(y); dec(x); end;
                           Sud  : begin dec(y); dec(x); end;
                      end;
                      while (x>0) and (LisScanlinePixelB(bmp,x,y)=1) do dec(x);
                      inc(x);
                      M:=LisScanlinesVersMire(bmp,x,y);
                      if (M.S=2) or (M.S=3) then
                      begin P2.x:=x; P2.y:=y; Result:=True;
                            //sms('Pointe A ou C');
                      end;
                end;
          end else
          if Direction=Est then
          begin x:=xct; y:=yct;
                while (x<bmp.width-1) and (LisScanlinePixelB(bmp,x,y)=1) do inc(x);
                dec(x);
                M:=LisScanlinesVersMire(bmp,x,y);
                if (M.S=5)
                and (((M.M[-1,0]=1)  and (M.M[-1,1]=1) and (M.M[0,1]=1)  and (M.M[1,1]=1))
                  or ((M.M[-1,-1]=1) and (M.M[-1,0]=1) and (M.M[0,-1]=1) and (M.M[1,-1]=1))) then
                begin P1.x:=x; P1.y:=y;
                      case InclineVers of
                           Nord : begin inc(y); inc(x); end;
                           Sud  : begin dec(y); inc(x); end;
                      end;
                      while (x<bmp.width-1) and (LisScanlinePixelB(bmp,x,y)=1) do inc(x);
                      dec(x);
                      M:=LisScanlinesVersMire(bmp,x,y);
                      if (M.S=2) or (M.S=3) then
                      begin P2.x:=x; P2.y:=y; Result:=True;
                            //sms('Pointe B ou D');
                      end;
                end;
          end else
          if Direction=Sud then
          begin x:=xct; y:=yct;
                while (y<bmp.height-1) and (LisScanlinePixelB(bmp,x,y)=1) do inc(y);
                dec(y);
                M:=LisScanlinesVersMire(bmp,x,y);
                if (M.S=5)
                and ( ((M.M[0,-1]=1)  and (M.M[1,-1]=1)  and (M.M[1,0]=1)  and (M.M[1,1]=1))
                   or ((M.M[-1,-1]=1) and (M.M[-1,0]=1) and (M.M[-1,1]=1) and (M.M[0,-1]=1))) then
                begin P1.y:=y; P1.x:=x;
                      case InclineVers of
                           Ouest: begin inc(x); inc(y); end;
                           Est  : begin dec(x); inc(y); end;
                      end;
                      while (y<bmp.height-1) and (LisScanlinePixelB(bmp,x,y)=1) do inc(y);
                      dec(y);
                      M:=LisScanlinesVersMire(bmp,x,y);
                      if (M.S=2) or (M.S=3) then
                      begin P2.y:=y; P2.x:=x; Result:=True;
                            //sms('Pointe Art ou Crt');
                      end;
                end;
          end else
          if Direction=Nord then
          begin x:=xct; y:=yct;
                while (y>0) and (LisScanlinePixelB(bmp,x,y)=1) do dec(y);
                inc(y);
                M:=LisScanlinesVersMire(bmp,x,y);
                if (M.S=5)
                and (((M.M[0,1]=1) and (M.M[1,-1]=1) and (M.M[1,0]=1)  and (M.M[1,1]=1))
                  or ((M.M[-1,-1]=1) and (M.M[-1,0]=1) and (M.M[-1,1]=1) and (M.M[0,1]=1))) then
                begin P1.x:=x; P1.y:=y;
                      case InclineVers of
                           Ouest : begin dec(y); inc(x); end;
                           Est   : begin dec(y); dec(x); end;
                      end;
                      while (y>0) and (LisScanlinePixelB(bmp,x,y)=1) do dec(y);
                      inc(y);
                      M:=LisScanlinesVersMire(bmp,x,y);
                      if (M.S=2) or (M.S=3) then
                      begin P2.x:=x; P2.y:=y; Result:=True;
                            //sms('Pointe Brt ou Drt');
                      end;
                end;
          end;
end; // CUnePointue
{ =========================================================================== }
function  RecoTrajectoire(bmp : tBitMap; xs,ys : integer) : boolean;
//   Recherche de la trajectoire
Label     Saut;
var       co,li, xct, yct, xct0, yct0, Tour, w, h, ind, xp, yp : integer ;
          redep, breakBSKP : boolean ;
          pa1, pa2 : TPoint ;
begin     Result:=False;
          Mire:=LisScanlinesVersMire(bmp,xs,ys);
          //Mire:=LisPixelsVersMire(bmp,xs,ys); : un peu + lent
          xct:=xs; yct:=ys;

          if Mire.M[0,0]=0 then // On centre la mire sur la trajectoire si on a cliqu  +1 ou moin 1 pixel prs
          begin co:=-2;
                repeat inc(co); li:=-2;
                       repeat inc(li);
                       until (li=1) or (Mire.M[co,li]=1);
                until (co=1) or (Mire.M[co,li]=1);
                xct:=xct+co; yct:=yct+li;
                Affinfos('Mire recentre sur traj en x='+intToStr(xct)+' y='+intToStr(yct));
          end;

          Mire:=LisScanlinesVersMire(bmp,xct,yct);
          //Mire:=LisPixelsVersMire(bmp,xct,yct);
          // A partir d'ici la mire contient au minimum 2 points "jaunes"
          xct0:=xct; yct0:=yct; // position de dpart suite  centrage

          xExt1:=-1; yExt1:=-1; xExt2:=-1; yExt2:=-1; redep:=False; breakBSKP:=False;
          ind:=-1; DP:=Station;
          w:=Bmp.width; h:=Bmp.Height;
       For Tour:=1 to 2 do
       // Reco en 2 tours :
       //  - 1er parcours jusqu' la 1re extrmit de trajectoire xExt1,yExt1,
       //  - puis 2me parcours en sens inverse pour numriser la trajectoire
       begin
          while (Mire.M[0,0]=1) do
          begin
                if Tour=2 then SauverPointTraj(xct,yct,ind);
                if Mire.S=2 then // Extrmits de trajectoire sur bord du Bmp ou ailleurs
                begin {if (xct=0) or (xct=w-1) or (yct=0) or (yct=h-1) then
                      begin //xExt1:=xct; yExt1:=yct; sms('xExt1, yExt1');
                      end; }
                      if (Tour=1) then
                      begin // Sur bords d''attaque :
                         if DP=Station then
                         begin
                            if (xct=0) and (yct>0) and (yct<h-1) and (Mire.M[-1,0]=1) then
                            begin xExt1:=xct; yExt1:=yct; PS:=Ouest; // en prvision du 2ime Tour
                                  Goto Saut;
                            end else
                            if (xct=w-1) and (yct=0) and (Mire.M[-1,1]=1) then
                            begin xExt1:=xct; yExt1:=yct; PS:=SudOuest;
                                   Goto Saut;
                            end else
                            if (xct>0) and (xct<w-1) and (yct=0) and (Mire.M[0,1]=1) then
                            begin xExt1:=xct; yExt1:=yct; PS:=Sud; Goto Saut;
                            end else
                            if (xct=0) and (yct=0) and (Mire.M[1,1]=1) then
                            begin xExt1:=xct; yExt1:=yct; PS:=SudEst; Goto Saut;
                            end else
                            if (xct=0) and (yct>0) and (yct<h-1) and (Mire.M[1,0]=1) then
                            begin xExt1:=xct; yExt1:=yct; PS:=Est; sms('Deb/bord gauche');
                                  Goto Saut;
                            end else
                            if (xct=0) and (yct=h-1) and (Mire.M[1,-1]=1) then
                            begin xExt1:=xct; yExt1:=yct; PS:=NordEst; Goto Saut;
                            end else
                            if (xct>0) and (xct<w-1) and (yct=h-1) and (Mire.M[0,-1]=1) then
                            begin xExt1:=xct; yExt1:=yct; PS:=Nord; Goto Saut;
                            end else
                            if (xct=w-1) and (yct=h-1) and (Mire.M[-1,-1]=1) then
                            begin xExt1:=xct; yExt1:=yct; PS:=SudEst; Goto Saut;
                            end else // Ailleurs que sur bords au 1er Tour = Debut/extrmit
                            begin if Mire.M[-1, 0]=1 then PS:=Ouest    else
                                  if Mire.M[-1, 1]=1 then PS:=SudOuest else
                                  if Mire.M[ 0, 1]=1 then PS:=Sud      else
                                  if Mire.M[ 1, 1]=1 then PS:=SudEst   else
                                  if Mire.M[ 1, 0]=1 then PS:=Est      else
                                  if Mire.M[ 1,-1]=1 then PS:=NordEst  else
                                  if Mire.M[ 0,-1]=1 then PS:=Nord     else
                                  if Mire.M[-1,-1]=1 then PS:=NordOuest;
                                  //sms('Debut/extrmit ailleurs que sur bord');
                                  xExt2:=xct; yExt2:=yct; DP:=PS;
                            end;
                         end; // if DP=Station au 1er Tour
                      end else // Tour=2
                      begin // Redpart Sur bords :
                            if (xct=0) and (yct>0) and (yct<h-1) and (Mire.M[-1,0]=1)
                            then PS:=Ouest else
                            if (xct=w-1) and (yct=0) and (Mire.M[-1,1]=1)
                            then PS:=SudOuest else
                            if (xct>0) and (xct<w-1) and (yct=0) and (Mire.M[0,1]=1)
                            then PS:=Sud else
                            if (xct=0) and (yct=0) and (Mire.M[1,1]=1)
                            then PS:=SudEst else
                            if (xct=0) and (yct>0) and (yct<h-1) and (Mire.M[1,0]=1)
                            then PS:=Est else
                            if (xct=0) and (yct=h-1) and (Mire.M[1,-1]=1)
                            then PS:=NordEst else
                            if (xct>0) and (xct<w-1) and (yct=h-1) and (Mire.M[0,-1]=1)
                            then PS:=Nord else
                            if (xct=w-1) and (yct=h-1) and (Mire.M[-1,-1]=1)
                            then PS:=SudEst
                            else // Redpart ailleurs que sur bord
                            begin //sms('Tour=2 : Redpart ailleurs DP='+PasToStr(DP));
                                  PS:=DirInverse(DP);
                                  //sms('Redpart vers PS='+PasToStr(PS));
                            end;
                            redep:=true;
                            xExt1:=xct; yExt1:=yct;
                      end;
                end else
                if Mire.S=3 then
                begin
                       if (Mire.M[-1,0]=1) and (Mire.M[1,0]=1) then // Passage horizontal
                       begin if DP=Station then PS:=Est else PS:=DP;
                       end else
                       if (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) then // Passage Vertical
                       begin if DP=Station then PS:=Nord else PS:=DP;
                       end else
                       if (Mire.M[-1,1]=1) and (Mire.M[1,-1]=1) then // Passage /
                       begin if DP=Station then PS:=NordEST else PS:=DP;
                       end else
                       if (Mire.M[-1,-1]=1) and (Mire.M[1,1]=1) then // Passage \
                       begin if DP=Station then PS:=NordOuest else PS:=DP;
                       end else // Suite = 4 angles droits centrs
                       if (Mire.M[0,1]=1) and (Mire.M[1,0]=1) then // Angle NordOuest
                       begin case DP of
                                  Station : PS:=Sud;
                                  Ouest   : PS:=Sud;
                                  Nord    : PS:=Est;
                             end;
                       end else
                       if (Mire.M[0,-1]=1) and (Mire.M[1,0]=1) then // Angle SudOuest
                       begin case DP of
                                  Station : PS:=Est;
                                  Ouest   : PS:=Nord;
                                  Sud     : PS:=Est
                              end;
                       end else
                       if (Mire.M[0,-1]=1) and (Mire.M[-1,0]=1) then // Angle SudEst
                       begin case DP of
                                  Station : PS:=Nord;
                                  Sud     : PS:=Ouest;
                                  Est     : PS:=Nord;
                             end;
                       end else
                       if (Mire.M[0,1]=1) and (Mire.M[-1,0]=1) then // Angle NordEst
                       begin case DP of
                                  Station : PS:=Ouest;
                                  Est     : PS:=Sud;
                                  Nord    : PS:=Ouest;
                             end;
                       end else // suite = 4 angles droits centrs en > < ^ et v
                       if (Mire.M[-1,-1]=1) and (Mire.M[-1,1]=1) then // Angle >
                       begin case DP of
                                  Station : PS:=NordOuest;
                                  SudEst  : PS:=SudOuest;
                                  NordEst : PS:=NordOuest;
                             end;
                       end else //
                       if (Mire.M[-1,1]=1) and (Mire.M[1,1]=1) then // Angle ^
                       begin case DP of
                                  Station  : PS:=SudEst;
                                  NordOuest: PS:=SudOuest;
                                  NordEst  : PS:=SudEst;
                             end;
                       end else //
                       if (Mire.M[1,1]=1) and (Mire.M[1,-1]=1) then // Angle <
                       begin case DP of
                                  Station  : PS:=SudEst;
                                  NordOuest: PS:=NordEst;
                                  SudOuest : PS:=SudEst;
                             end;
                       end else //
                       if (Mire.M[-1,-1]=1) and (Mire.M[1,-1]=1) then // Angle v
                       begin case DP of
                                  Station      : PS:=NordEst;
                                  SudOuest : PS:=NordOuest;
                                  SudEst   : PS:=NordEst;
                             end;
                       end else // Suite = 8 Cornes centres d''angles
                       if (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then //***
                       begin case DP of
                                  Station,Ouest : PS:=SudEst;
                                  NordOuest : PS:=Est;
                             end;
                       end else
                       if (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) then //***
                       begin case DP of
                                  Station,Sud  : PS:=NordEst;
                                  SudOuest : PS:=Nord;
                             end;
                       end else
                       if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) then //***
                       begin case DP of
                                  Station,Est  : PS:=NordOuest;
                                  SudEst   : PS:=Ouest;
                             end;
                       end else
                       if (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1) then //***
                       begin case DP of
                                  Station,Sud : PS:=NordOuest;
                                  SudEst  : PS:=Nord;
                             end;
                       end else
                       if (Mire.M[-1,1]=1) and (Mire.M[0,1]=1) then //***
                       begin case DP of
                                  Station,Nord : PS:=SudOuest;
                                  NordEst  : PS:=Sud;
                             end;
                       end else
                       if (Mire.M[1,-1]=1) and (Mire.M[1,0]=1) then //***
                       begin case DP of
                                  Station,Ouest : PS:=NordEst;
                                  SudOuest  : PS:=Est;
                             end;
                       end else
                       if (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1) then //***
                       begin case DP of
                                  Station,Est : PS:=SudOuest;
                                  NordEst : PS:=Ouest;
                             end;
                       end else
                       if (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then //***
                       begin case DP of
                                  Station,Nord : PS:=SudEst;
                                  NordOuest: PS:=Sud;
                             end;
                       end else // suite = 8 angles obtus centrs en demi-Y
                       if (Mire.M[-1,-1]=1) and (Mire.M[0,1]=1) then
                       begin case DP of
                                  Station     : PS:=NordOuest;
                                  SudEst  : PS:=Sud;
                                  Nord    : PS:=NordOuest;
                             end;
                       end else
                       if (Mire.M[0,1]=1) and (Mire.M[1,-1]=1) then
                       begin case DP of
                                  Station     : PS:=NordEst;
                                  SudOuest: PS:=Sud;
                                  Nord    : PS:=NordEst;
                             end;
                       end else
                       if (Mire.M[0,-1]=1) and (Mire.M[1,1]=1) then
                       begin case DP of
                                  Station      : PS:=SudEst;
                                  NordOuest: PS:=Nord;
                                  Sud      : PS:=SudEst;
                             end;
                       end else
                       if (Mire.M[0,-1]=1) and (Mire.M[-1,1]=1) then
                       begin case DP of
                                  Station  : PS:=SudOuest;
                                  Sud      : PS:=SudOuest;
                                  NordEst  : PS:=Nord;
                             end;
                       end else
                       if (Mire.M[-1,0]=1) and (Mire.M[1,-1]=1) then
                       begin case DP of
                                  Station  : PS:=NordEst;
                                  SudOuest : PS:=Ouest;
                                  Est      : PS:=NordEst;
                             end;
                       end else
                       if (Mire.M[-1,0]=1) and (Mire.M[1,1]=1) then
                       begin case DP of
                                  Station  : PS:=SudEst;
                                  NordOuest: PS:=Ouest;
                                  Est      : PS:=SudEst;
                             end;
                       end else
                       if (Mire.M[1,0]=1) and (Mire.M[-1,1]=1) then
                       begin case DP of
                                  Station,Ouest  : PS:=SudOuest;
                                  NordEst    : PS:=Est;
                             end;
                       end else
                       if (Mire.M[1,0]=1) and (Mire.M[-1,-1]=1) then
                       begin case DP of
                                  Station,SudEst : PS:=Est;
                                  Ouest      : PS:=NordOuest;
                             end;
                       end else
                       begin sms('autre cas avec Somme Mire.S=3 : oubli ?');
                             AffMire(Mire, xct,yct);
                             xExt2:=xct; yExt2:=yct;
                       end;
                end else
                if Mire.S=4 then
                begin // "T" centrs formant soit une traverse soit une fin de trajectoire, soit une fin d''angle
                      if (Mire.M[-1,0]=1) and (Mire.M[0,1]=1) and (Mire.M[1,0]=1) then // 000
                      begin if RienAlEst(bmp,xct,yct) then // Fin d''angle             // 111
                            begin SauverPointTraj(xct+1,yct,ind);                      // 010
                                  case DP of
                                       Station,Nord : PS:=Ouest;
                                       Est          : PS:=Sud;
                                       else sms('T1.1');
                                  end;
                            end else
                            if RienAlOuest(bmp,xct,yct) then // Fin d''angle
                            begin SauverPointTraj(xct-1,yct,ind);
                                  case DP of
                                       Station,Nord : PS:=Est;
                                       Ouest        : PS:=Sud;
                                       else sms('T1.2 '+PasToStr(DP));
                                  end;
                            end else
                            if DP=Nord then begin xExt2:=xct; yExt2:=yct; BreakBSKP:=True; end // fin de traj
                            else begin sms('T1.3'); AffMire(Mire, xct,yct); end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) and (Mire.M[1,0]=1) then // 010
                      begin if RienAuSud(bmp,xct,yct) then // Fin d''angle             // 011
                            begin SauverPointTraj(xct,yct+1,ind);                      // 010
                                  case DP of
                                       Station,Ouest: PS:=Nord;
                                       Sud          : PS:=Est;
                                       else sms('T2.1 '+PasToStr(DP));
                                  end;
                            end else
                            if RienAuNord(bmp,xct,yct) then // Fin d''angle
                            begin SauverPointTraj(xct,yct-1,ind);
                                  case DP of
                                       Station,Nord : PS:=Est;
                                       Ouest        : PS:=Sud;
                                       else begin sms('T2.2 '+PasToStr(DP)); AffMire(Mire, xct,yct); end;
                                  end;
                            end else 
                            if DP=Ouest then begin xExt2:=xct; yExt2:=yct; BreakBSKP:=True; end // fin de traj
                            else begin sms('T2.3'); AffMire(Mire, xct,yct); end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[0,-1]=1) and (Mire.M[1,0]=1) then // 010
                      begin if RienAlEst(bmp,xct,yct) then // Fin d''angle              // 111
                            begin SauverPointTraj(xct+1,yct,ind);                       // 000
                                  case DP of
                                       Station,Sud : PS:=Ouest;
                                       Est         : PS:=Nord;
                                       else sms('T3.1');
                                  end;
                            end else
                            if RienAlOuest(bmp,xct,yct) then // Fin d''angle
                            begin SauverPointTraj(xct-1,yct,ind);
                                  case DP of
                                       Station,Ouest : PS:=Nord;
                                       Sud           : PS:=Est;
                                       else sms('T3.2 '+PasToStr(DP));
                                  end;
                            end else
                            if DP=Sud then begin xExt2:=xct; yExt2:=yct; BreakBSKP:=True; end // fin de traj
                            else begin sms('T3.3'); AffMire(Mire, xct,yct); end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) then // 010
                      begin if RienAuNord(bmp,xct,yct) then // Fin d''angle             // 110
                            begin SauverPointTraj(xct,yct-1,ind);                       // 010
                                  case DP of
                                       Station,Nord : PS:=Ouest;
                                       Est          : PS:=Sud;
                                       else sms('T4.1');
                                  end;
                            end else
                            if RienAuSud(bmp,xct,yct) then // Fin d''angle
                            begin SauverPointTraj(xct,yct+1,ind);
                                  case DP of
                                       Station,Sud : PS:=Ouest;
                                       Est         : PS:=Nord;
                                       else sms('T4.2');
                                  end;
                            end else
                            if DP=Est then begin xExt2:=xct; yExt2:=yct; BreakBSKP:=True; end
                            else begin sms('T4.3'); AffMire(Mire, xct,yct); end;
                      end else // angles  45 corns
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1) and (Mire.M[-1,1]=1) then
                      begin if RienAuNord(bmp,xct,yct) then
                            begin case DP of
                                       Station     : PS:=Nord;
                                       NordEst : PS:=Nord;
                                       Sud     : PS:=SudOuest;
                                  end;
                            end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1) and (Mire.M[1,1]=1) then
                      begin if RienAlOuest(bmp,xct,yct) then
                            begin case DP of
                                       Station  : PS:=Ouest;
                                       NordOuest: PS:=Ouest;
                                       Est      : PS:=SudEst;
                                  end;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[1,0]=1) and (Mire.M[1,-1]=1) then
                      begin if RienAlEst(bmp,xct,yct) then
                            begin case DP of
                                       Station    : PS:=Est;
                                       SudEst : PS:=Est;
                                       Ouest  : PS:=NordOuest;
                                  end;
                            end;
                      end else
                      if (Mire.M[1,-1]=1) and (Mire.M[1,1]=1) and (Mire.M[0,1]=1) then
                      begin if RienAuSud(bmp,xct,yct) then
                            begin case DP of
                                       Station : PS:=Sud;
                                       SudOuest: PS:=Sud;
                                       Nord    : PS:=NordEst;
                                  end;
                            end;
                      end else // "Y" de bifurcation : retenu sens de circulation routire
                               // + fin de trajectoire si retour en sens inverse
                      if (Mire.M[-1,0]=1) and (Mire.M[1,-1]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=SudEst;
                                 Est      : PS:=SudEst;
                                 SudOuest : PS:=Ouest;
                                 NordOuest: begin xExt2:=xct; yExt2:=yct; BreakBSKP:=True; end;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,1]=1) and (Mire.M[1,-1]=1) then
                      begin case DP of
                                 Station  : PS:=NordEst;
                                 Nord     : PS:=NordEst;
                                 SudEst   : PS:=Sud;
                                 SudOuest : begin xExt2:=xct; yExt2:=yct; BreakBSKP:=True; end;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,1]=1) and (Mire.M[1,0]=1) then
                      begin case DP of
                                 Station  : PS:=NordOuest;
                                 Ouest    : PS:=NordOuest;
                                 NordEst  : PS:=Est;
                                 SudEst   : begin xExt2:=xct; yExt2:=yct; BreakBSKP:=True; end;
                            end;
                      end else
                      if (Mire.M[-1,1]=1) and (Mire.M[1,1]=1) and (Mire.M[0,-1]=1) then
                      begin case DP of
                                 Station  : PS:=SudEst;
                                 Sud      : PS:=SudEst;
                                 NordOuest: PS:=Nord;
                                 NordEst  : begin xExt2:=xct; yExt2:=yct; BreakBSKP:=True; end;
                            end;
                      end else // Traverses en zig :
                      if (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1) and (Mire.M[1,-1]=1) then
                      begin case DP of
                                 Station  : PS:=NordEst;
                                 Est      : PS:=NordEst;
                                 SudOuest : PS:=Ouest;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=NordOuest;
                                 Nord     : PS:=NordOuest;
                                 SudEst   : PS:=Sud;
                            end;
                      end else
                      if (Mire.M[-1,1]=1) and (Mire.M[1,0]=1) and (Mire.M[1,-1]=1) then
                      begin case DP of
                                 Station  : PS:=Est;
                                 NordEst  : PS:=Est;
                                 Ouest    : PS:=SudOuest;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=Nord;
                                 NordOuest: PS:=Nord;
                                 Sud      : PS:=SudEst;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=ESt;
                                 SudEst   : PS:=ESt;
                                 Ouest    : PS:=NordOuest;
                            end;
                      end else
                      if (Mire.M[-1,1]=1) and (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) then
                      begin case DP of
                                 Station  : PS:=Nord;
                                 NordEst  : PS:=Nord;
                                 Sud      : PS:=SudOuest;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=Ouest;
                                 NordOuest: PS:=Ouest;
                                 Est      : PS:=SudEst;
                            end;
                      end else
                      if (Mire.M[-1,1]=1) and (Mire.M[0,1]=1) and (Mire.M[1,-1]=1) then
                      begin case DP of
                                 Station  : PS:=Sud;
                                 SudOuest : PS:=Sud;
                                 Nord     : PS:=NordEst;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) and (Mire.M[0,1]=1) then
                      begin case DP of
                                 Station  : PS:=Sud;
                                 Est      : PS:=Sud;
                                 Nord     : PS:=Ouest;
                            end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=Est;
                                 Sud      : PS:=Est;
                                 Ouest    : PS:=Nord;
                            end;
                      end else // 8 cas d''Approche ou de suite d'angles droits
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) then
                      begin case DP of
                                 Station  : PS:=Nord;
                                 Nord     : PS:=Nord;
                                 Sud      : PS:=Sud;
                            end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1) and (Mire.M[1,0]=1) then
                      begin case DP of
                                 Station  : PS:=Ouest;
                                 Ouest    : PS:=Ouest;
                                 Nord     : PS:=Est;
                            end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=Sud;
                                 Sud      : PS:=Sud;
                                 Nord     : PS:=Nord;
                            end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[1,0]=1) and (Mire.M[1,-1]=1) then
                      begin case DP of
                                 Station  : PS:=Est;
                                 Sud      : PS:=Est;
                                 Ouest    : PS:=Ouest;
                            end;
                      end else // 4 suiv
                      if (Mire.M[-1,0]=1) and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=Ouest;
                                 Ouest    : PS:=Ouest;
                                 Est      : PS:=Est;
                            end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) and (Mire.M[1,-1]=1) then
                      begin case DP of
                                 Station  : PS:=Sud;
                                 Sud      : PS:=Sud;
                                 Nord     : PS:=Nord;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) and (Mire.M[1,0]=1) then
                      begin case DP of
                                 Station  : PS:=Est;
                                 Est      : PS:=Est;
                                 Ouest    : PS:=Ouest;
                            end;
                      end else
                      if (Mire.M[-1,1]=1) and (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) then
                      begin case DP of
                                 Station  : PS:=Nord;
                                 Nord     : PS:=Nord;
                                 Sud      : PS:=Sud;
                            end;
                      end else // 4 angles  45 corns
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,1]=1) and (Mire.M[0,1]=1) then
                      begin case DP of
                                 Station  : PS:=NordOuest;
                                 Nord     : PS:=NordOuest;
                                 SudEst   : PS:=Sud;
                            end;
                      end else
                      if (Mire.M[-1,1]=1) and (Mire.M[1,1]=1) and (Mire.M[1,0]=1) then
                      begin case DP of
                                 Station  : PS:=SudOuest;
                                 Ouest    : PS:=SudOuest;
                                 NordEst  : PS:=Est;
                            end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) and (Mire.M[1,1]=1) then
                      begin case DP of
                                 Station  : PS:=SudEst;
                                 Sud      : PS:=SudEst;
                                 NordOuest: PS:=Nord;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) and (Mire.M[1,-1]=1) then
                      begin case DP of
                                 Station,Est  : PS:=NordEst;
                                 SudOuest : PS:=Ouest;
                            end;
                      end else
                      if (Mire.M[1,-1]=1) and (Mire.M[1,0]=1) and (Mire.M[0,1]=1) then // 001
                      begin case DP of                                                 // 011
                                 Station,Ouest : PS:=Sud;                                  // 010
                                 Nord      : PS:=Est;
                            end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then // 000
                      begin case DP of                                                 // 110
                                 Station,Est : PS:=Sud;                                    // 011
                                 Nord    : PS:=Ouest;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1) and (Mire.M[1,0]=1) then // 110
                      begin case DP of                                                   // 011
                                 Station,Sud : PS:=Est;                                      // 000
                                 Ouest   : PS:=Nord;
                            end;
                      end else
                      if (Mire.M[-1,1]=1) and (Mire.M[0,1]=1) and (Mire.M[1,0]=1) then // 000
                      begin case DP of                                                 // 011
                                 Station,Nord: PS:=Est;                                    // 110
                                 Ouest   : PS:=Sud;
                            end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1) then // 010
                      begin case DP of                                                   // 110
                                 Station,Est : PS:=Nord;                                 // 100
                                 Sud     : PS:=Ouest;
                            end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) and (Mire.M[-1,0]=1) then // 011
                      begin case DP of                                                   // 110
                                 Station,Est : PS:=Nord;                                 // 000
                                 Sud         : PS:=Ouest;
                            end;
                      end else // suite = 4 Pointes d'angles ~81 90
                      if (Mire.M[-1,1]=1) and (Mire.M[0,-1]=1) and (Mire.M[1,0]=1) then // 010
                      begin if RienAlEst(bmp,xct,yct) then                              // 011
                            begin SauverPointTraj(xct+1,yct,ind);                       // 100
                                  case DP of
                                       Station,NordEst : PS:=Nord;
                                       Sud             : PS:=SudOuest;
                                       else sms('Pointes ~90 A');
                                  end;
                            end else sms('Pointes ~90 B');
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[0,-1]=1) and (Mire.M[1,1]=1) then // 010
                      begin if RienAuNord(bmp,xct,yct) then                             // 110
                            begin SauverPointTraj(xct,yct-1,ind);                       // 001
                                  case DP of
                                       Station,NordOuest: PS:=Ouest;
                                       Est              : PS:=SudEst;
                                       else sms('Pointes ~90 C');
                                  end;
                            end else sms('Pointes ~90 D');
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[0,1]=1) and (Mire.M[1,-1]=1) then // 001
                      begin if RienAlOuest(bmp,xct,yct) then                            // 110
                            begin SauverPointTraj(xct-1,yct,ind);                       // 010
                                  case DP of
                                       Station,SudOuest: PS:=Sud;
                                       Nord            : PS:=NordEst;
                                       else sms('Pointes ~90 D');
                                  end;
                            end else sms('Pointes ~90 E');
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,1]=1) and (Mire.M[1,0]=1) then // 100
                      begin if RienAuSud(bmp,xct,yct) then                              // 011
                            begin SauverPointTraj(xct,yct+1,ind);                       // 010
                                  case DP of
                                       Station,SudEst : PS:=Est;
                                       Ouest          : PS:=NordOuest;
                                       else sms('Pointes ~90 E');
                                  end;
                            end else
                            if RienAlEst(bmp,xct,yct) then
                            begin SauverPointTraj(xct+1,yct,ind);
                                  case DP of
                                       Station,SudEst : PS:=Sud;
                                       Nord           : PS:=NordOuest;
                                       else sms('Pointes ~90 F');
                                  end;
                            end else sms('Pointes ~90 G');
                      end else begin sms('Mire.S=4 : cas non fait');
                                     AffMire(Mire, xct,yct);
                      end;
                end else
                if Mire.S=5 then
                begin  // Marche en avant aux croisements :
                       // Croisements centrs  angle droit:
                       if  (Mire.M[-1,0]=1) and (Mire.M[1,0]=1)
                       and (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) then // Croisement en "+"
                       begin if DP=Station then PS:=Est else PS:=DP;
                       end else
                       if  (Mire.M[-1,-1]=1) and (Mire.M[1,1]=1)
                       and (Mire.M[-1,1]=1) and (Mire.M[1,-1]=1)  then // Croisement en "x"
                       begin if DP=Station then PS:=NordEst else PS:=DP;
                       end else
                       // Avant et aprs croisements  90 60:
                       if  (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)      // 100
                       and (Mire.M[-1,1]=1) and (Mire.M[1,0]=1) then   // 111
                       begin if (LisScanlinePixelB(bmp,xct-2,yct+2)=1) // 100
                             and RienAlOuest(bmp,xct,yct) then         //1
                             begin case DP of  // 60 e3)
                                        Station,Ouest          : PS:=SudOuest;
                                        SudEst,Est,NordEst : PS:=Est;
                                   end;
                             end else
                             if (LisScanlinePixelB(bmp,xct-2,yct-2)=1)
                             and RienAlOuest(bmp,xct,yct) then
                             begin case DP of  // 60 e4)
                                        Station,Ouest          : PS:=NordOuest;
                                        SudEst,Est,NordEst : PS:=Est;
                                   end;
                             end else if DP=Station then PS:=Est else PS:=DP; 
                       end else
                       if  (Mire.M[-1,1]=1) and (Mire.M[0,-1]=1)        // 010
                       and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then     // 010
                       begin if (LisScanlinePixelB(bmp,xct-2,yct+2)=1)  // 111
                             and RienAuSud(bmp,xct,yct) then            //1
                             begin case DP of  // 60 c1)
                                        Station,Sud      : PS:=SudOuest;
                                        Nord,NordEst : PS:=Nord;
                                   end;
                             end else
                             if (LisScanlinePixelB(bmp,xct+2,yct+2)=1)
                             and RienAuSud(bmp,xct,yct) then
                             begin case DP of // 60 c2)
                                        Station,Sud       : PS:=SudEst;
                                        Nord,NordOuest: PS:=Nord;
                                   end;
                             end else if DP=Station then PS:=Nord else PS:=DP; // 90
                       end else                                        //1
                       if  (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1)      // 111
                       and (Mire.M[1,-1]=1) and (Mire.M[0,1]=1) then   // 010
                       begin if (LisScanlinePixelB(bmp,xct-2,yct-2)=1) // 010
                             and RienAuNord(bmp,xct,yct) then
                             begin case DP of // 60 d1)
                                        Station,Nord     : PS:=NordOuest;
                                        Sud,SudEst   : PS:=Sud;
                                   end;
                             end else
                             if (LisScanlinePixelB(bmp,xct+2,yct-2)=1)
                             and RienAuNord(bmp,xct,yct) then
                             begin case DP of // 60 d2)
                                        Station,Nord     : PS:=NordEst;
                                        Sud,SudOuest : PS:=Sud;
                                   end;
                             end else
                             begin case DP of // 90
                                        Station,Nord     : PS:=Nord;
                                        Sud,SudOuest : PS:=Sud;
                                   end;
                             end;
                       end else
                       if  (Mire.M[-1,0]=1) and (Mire.M[1,1]=1)             // 001
                       and (Mire.M[1,0]=1) and (Mire.M[1,-1]=1) then        // 111
                       begin if (LisScanlinePixelB(bmp,xct+2,yct-1)=1) then // 001                    // 001
                             begin case DP of // 60 e1)
                                        Station,Est        : PS:=Est;
                                        SudOuest,Ouest : PS:=Ouest;
                                        else sms('bug sur e1)?');
                                   end;
                             end else
                             if (LisScanlinePixelB(bmp,xct+2,yct+1)=1) then                    // 001
                             begin case DP of // 60 e2)
                                        Station,Est         : PS:=Est;
                                        NordOuest,Ouest : PS:=Ouest;
                                        else sms('bug sur e2)?');
                                   end;
                             end else
                             if (LisScanlinePixelB(bmp,xct+2,yct-2)=1) then                    // 001
                             begin case DP of // 60 d31)
                                        Station,Est  : PS:=NordEst;
                                        SudOuest : PS:=Ouest;
                                        else sms('bug sur d31)?');
                                   end;
                             end else
                             if (LisScanlinePixelB(bmp,xct+2,yct+2)=1) then                    // 001
                             begin case DP of // 60 d32)
                                        Station,Est   : PS:=SudEst;
                                        NordOuest : PS:=Ouest;
                                        else sms('bug sur d32)?');
                                   end;
                             end else
                             begin case DP of
                                        Station,Est                  : PS:=Est;
                                        NordOuest,Ouest,SudOuest : PS:=Ouest;
                                        else sms('bug sur e2)?');
                                   end;
                             end;
                       end else
                       if  (Mire.M[-1,0]=1) and (Mire.M[0,-1]=1)     // 011
                       and (Mire.M[0,1]=1) and (Mire.M[1,-1]=1) then // 110
                       begin case DP of // 60 f)                    // 010
                                  Station,Est  : PS:=NordEst;
                                  SudOuest : PS:=Ouest;
                                  Sud      : PS:=Sud;
                                  Nord     : PS:=Nord;
                                  else sms('bug sur f)?');
                             end;
                       end else
                       if  (Mire.M[-1,0]=1) and (Mire.M[0,-1]=1)    // 010
                       and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then // 110
                       begin case DP of // 60 g)                   // 011
                                  Station,Est   : PS:=SudEst;
                                  NordOuest : PS:=Ouest;
                                  Sud       : PS:=Sud;
                                  Nord      : PS:=Nord;
                                  else sms('bug sur g)?');
                             end;
                       end else
                       if  (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1)   // 110
                       and (Mire.M[0,1]=1) and (Mire.M[1,0]=1) then // 011
                       begin case DP of // 60 h)                   // 010
                                  Station,Sud   : PS:=Sud;
                                  Nord      : PS:=Nord;
                                  Ouest     : PS:=NordOuest;
                                  SudEst    : PS:=Est;
                                  else sms('bug sur h)?');
                             end;
                       end else // 4 Croisements  45 60:
                       if  (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1)       // 001
                       and (Mire.M[1,0]=1) and (Mire.M[1,-1]=1) then   // 111 b)
                       begin case DP of                                // 100
                                  Station,Est  : PS:=Est;
                                  Ouest    : PS:=Ouest;
                                  SudOuest : PS:=SudOuest;
                                  NordEst  : PS:=NordEst;
                             end;
                       end else
                       if  (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)   // 100
                       and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then // 111 b1)
                       begin case DP of                             // 001
                                  Station,Est   : PS:=Est;
                                  Ouest     : PS:=Ouest;
                                  SudEst    : PS:=SudEst;
                                  NordOuest : PS:=NordOuest;
                             end;
                       end else
                       if  (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1)   // 110
                       and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then // 010 b2)
                       begin case DP of                             // 011
                                  Station,Sud   : PS:=Sud;
                                  Nord      : PS:=Nord;
                                  NordOuest : PS:=NordOuest;
                                  SudEst    : PS:=SudEst;
                             end;
                       end else
                       if  (Mire.M[-1,1]=1) and (Mire.M[0,-1]=1)     // 011
                       and (Mire.M[0,1]=1) and (Mire.M[1,-1]=1) then // 010 b3)
                       begin case DP of                              // 110
                                  Station,Sud  : PS:=Sud;
                                  Nord     : PS:=Nord;
                                  NordEst  : PS:=NordEst;
                                  SudOuest : PS:=SudOuest;
                             end;     
                       end else
                       // Suite= 4 cas de retours en "c"
                       if  (Mire.M[0,-1]=1) and (Mire.M[0,1]=1)
                       and (Mire.M[1,-1]=1) and (Mire.M[1,1]=1) then
                       begin if DP=Station then PS:=Sud else PS:=DP;
                       end else
                       if  (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)
                       and (Mire.M[1,0]=1) and (Mire.M[1,-1]=1) then
                       begin if DP=Station then PS:=Est else PS:=DP;
                       end else
                       if  (Mire.M[-1,-1]=1) and (Mire.M[-1,1]=1)
                       and (Mire.M[0,1]=1) and (Mire.M[0,-1]=1) then
                       begin if DP=Station then PS:=Nord else PS:=DP;
                       end else
                       if  (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1)
                       and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then
                       begin if DP=Station then PS:=Ouest else PS:=DP;
                       end else // suite = angles <=45 ou croisements  environ 45
                       if (Mire.M[-1,1]=1) and (Mire.M[0,1]=1)                     // 001
                       and (Mire.M[1,-1]=1) and (Mire.M[1,1]=1) then               // 010
                       begin if RienAuSudOuest(bmp,xct,yct) then                   // 111
                             begin case DP of // Pointe d''angle PointTraj() sauv en S=4 <<<
                                        Station,SudOuest : PS:=Sud;
                                        Nord             : PS:=NordEst;
                                        else sms('angle  ~45 imprvu 2 DP='+PasToStr(DP));
                                   end;
                             end else
                             case DP of // Croisement
                                        Station      : PS:=Sud;
                                        SudOuest     : PS:=SudOuest;
                                        NordEst,Nord : PS:=NordEst;
                                        else sms('angle  ~45 imprvu 1');
                                   end;
                       end else
                       if (Mire.M[-1,-1]=1) and (Mire.M[-1,1]=1)    // 100
                       and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then // 010
                       begin if RienAuSudEst(bmp,xct,yct) then      // 111
                             begin case DP of // Pointe d''angle PointTraj() dj sauv en S=4 <<<
                                        Station,SudEst : PS:=Sud;
                                        Nord           : PS:=NordOuest;
                                        else sms('angle  ~45 imprvu 2');
                                   end;
                             end else
                             begin case DP of // croisement
                                        Station,Nord,NordEst,NordOuest : PS:=NordOuest;
                                        SudEst   : PS:=SudEst;
                                        else sms('angle  ~45 imprvu 3');
                                   end;
                             end;
                       end else
                       if (Mire.M[-1,-1]=1) and (Mire.M[1,-1]=1)    // 101
                       and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then // 011
                       begin if RienAuSudEst(bmp,xct,yct) then      // 001
                             begin case DP of // Pointe d''angle PointTraj() sauv en S=4 <<<
                                        Station,Ouest : PS:=NordOuest;
                                        SudEst        : PS:=Est;
                                        else sms('angle  ~45 imprvu 4');
                                   end;
                             end else
                             begin case DP of // Croisement
                                        Station,SudEst : PS:=SudEst;
                                        Ouest,NordOuest,SudOuest : PS:=NordOuest;
                                        else sms('angle  ~45 imprvu 5');
                                   end;
                             end;
                       end else
                       if (Mire.M[-1,1]=1) and (Mire.M[1,1]=1)       // 001
                       and (Mire.M[1,0]=1) and (Mire.M[1,-1]=1) then // 011
                       begin if RienAuNordEst(bmp,xct,yct) then      // 101
                            begin // Pointe d''angle PointTraj() dj sauv en S=4 <<<
                                  case DP of
                                       Station,Ouest : PS:=SudOuest;
                                       NordEst       : PS:=Est;
                                       else sms('angle  ~45 imprvu 6');
                                  end;
                            end else
                            begin case DP of // croisement :
                                       Station,NordEst : PS:=NordEst;
                                       Ouest,SudOuest,NordOuest : PS:=SudOuest;
                                       else sms('angle  ~45 imprvu 7');
                                  end;
                            end;
                       end else
                      if (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1)       // 111
                      and (Mire.M[1,1]=1) and (Mire.M[-1,-1]=1) then // 010
                      begin if RienAuNordOuest(bmp,xct,yct) then     // 001
                            begin // Pointe d''angle PointTraj() sauv en S=4  <<<
                                  case DP of
                                       Station,NordOuest : PS:=Nord;
                                       Sud               : PS:=SudEst;
                                       else sms('angle  ~45 imprvu 8');
                                  end;
                            end else
                            begin case DP of // Croisement
                                       Station,SudEst,Sud,SudOuest : PS:=SudEst;
                                       NordOuest: PS:=NordOuest;
                                       else sms('angle  ~45 imprvu 9');
                                  end;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)       // 101
                      and (Mire.M[-1,1]=1) and (Mire.M[1,-1]=1)  then // 110
                      begin if RienAuSudOuest(bmp,xct,yct) then       // 100
                            begin // Pointe d''angle  PointTraj() sauv en S=4 <<<
                                  // Faire de mme pour cas similaire ici en S=5
                                  case DP of
                                       Station,SudOuest : PS:=Ouest;
                                       Est              : PS:=NordEst;
                                       else begin sms('angle  ~45 imprvu 10 '+PasToStr(DP));
                                                  AffMire(Mire, xct,yct);
                                       end;
                                  end;
                            end else
                            begin case DP of // Croisement
                                       Station,SudOuest : PS:=SudOuest;
                                       Est,SudEst,NordEst : PS:=NordEst;
                                       else sms('angle  ~45 imprvu 11');
                                  end;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,1]=1)      // 111
                      and (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) then // 010
                      begin if RienAuNordEst(bmp,xct,yct) then       // 100
                            begin // Pointe d''angle : PointTraj() sauv en S=4 <<<
                                  case DP of
                                       Station,NordEst : PS:=Nord;
                                       Sud             : PS:=SudOuest;
                                       else sms('angle  ~45 imprvu 12');
                                  end;
                            end else
                            begin case DP of // Croisement :
                                       Station,Sud,SudOuest,SudEst : PS:=SudOuest;
                                       NordEst : PS:=NordEst;
                                       else sms('angle  ~45 imprvu 13');
                                  end;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)     // 100
                      and (Mire.M[-1,1]=1) and (Mire.M[1,1]=1) then // 110
                      begin if RienAuNordOuest(bmp,xct,yct) then    // 101
                            begin // Pointe d''angle PointTraj() sauv en S=4 <<<
                                  case DP of
                                       Station,NordOuest : PS:=Ouest;
                                       Est               : PS:=SudEst;
                                       else sms('angle  ~45 imprvu 14');
                                  end;
                            end else
                            begin case DP of // Croisement
                                       Station,SudEst,Est,NordEst : PS:=SudEst;
                                       NordOuest              : PS:=NordOuest;
                                       else sms('angle  ~45 imprvu 15');
                                  end;
                            end;
                      end else // Suite = 4 cas "carr de 4 pixels + 1 pixel dans un des angles de Mire"
                      if (Mire.M[1,-1]=1) and (Mire.M[-1,0]=1)      // 001
                      and (Mire.M[-1,1]=1) and (Mire.M[0,1]=1) then // 110
                      begin case DP of                              // 110
                                 Station,SudOuest : PS:=SudOuest;
                                 else PS:=NordEst;
                            end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1)      // 011
                      and (Mire.M[1,0]=1) and (Mire.M[-1,1]=1) then // 011
                      begin case DP of                              // 100
                                 Station,NordEst : PS:=NordEst;
                                 else PS:=SudOuest;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)     // 110
                      and (Mire.M[0,-1]=1) and (Mire.M[1,1]=1) then // 110
                      begin case DP of                              // 001
                                 Station,NordOuest : PS:=NordOuest;
                                 else PS:=SudEst;
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[1,0]=1)     // 100
                      and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then // 011
                      begin case DP of                             // 011
                                 Station,SudEst : PS:=SudEst;
                                 else PS:=NordOuest;
                            end;
                      end else //-----------------------------------------
                      if (Mire.M[-1,0]=1) and (Mire.M[0,1]=1)       // 001
                      and (Mire.M[1,0]=1) and (Mire.M[1,-1]=1) then // 111 croisement 64  62
                      begin case DP of                              // 010
                                 Station,SudOuest : PS:=Sud;
                                 Ouest        : PS:=Ouest;
                                 Est          : PS:=Est;
                                 Nord         : PS:=NordEst;
                                 else sms('croisement  ~63 imprvu 16');
                            end;
                      end else
                      if (Mire.M[0,-1]=1) and (Mire.M[1,0]=1)
                      and (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1) then // avant ou aprs croisement 64  62
                      begin if (DP=Station) or (DP=Sud) then PS:=SudOuest
                            else case ADP of
                                      Ouest   : PS:=Ouest;
                                      Est     : PS:=Est;
                                      Nord,NordEst : PS:=Nord;
                                      else sms('croisement  ~45 imprvu 17');
                                 end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)
                      and (Mire.M[0,1]=1) and (Mire.M[1,0]=1) then // croisement 116  118
                      begin if (DP=Station) or (DP=Nord) then PS:=Ouest
                            else case ADP of
                                      Ouest   : PS:=Ouest;
                                      Est     : PS:=Est;
                                      Sud     : PS:=Sud;
                                      else sms('croisement  ~45 imprvu 18');
                                 end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[0,-1]=1)
                      and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then // approche ou suite croisement 116  118
                      begin if (DP=Station) or (DP=Sud) then PS:=Est
                            else case ADP of
                                      Ouest   : PS:=Ouest;
                                      Est     : PS:=Est;
                                      NordOuest,NordEst,Nord : PS:=Nord
                                      else sms('croisement  ~45 imprvu 19');
                                 end;
                      end else // bifurques et angles :
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1)    // 110
                      and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then // 011
                      begin case DP of                             // 001
                                 Station,Ouest   : PS:=Nord;
                                 Sud             : PS:=Est;
                                 else sms('angle imprvu 20');
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,-1]=1)     // 110
                      and (Mire.M[1,0]=1) and (Mire.M[-1,1]=1) then // 011
                      begin case DP of                              // 100
                                 Station,Ouest   : PS:=Nord;
                                 NordEst         : PS:=Est;
                                 else sms('angle imprvu 21');
                            end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[0,-1]=1)      // 011
                      and (Mire.M[1,-1]=1) and (Mire.M[1,1]=1) then // 110
                      begin case DP of                              // 001
                                 Station,Est : PS:=Nord;
                                 NordOuest   : PS:=Ouest;
                                 Sud         : PS:=Est;
                                 else sms('angle imprvu 22');
                            end;
                      end else
                      if (Mire.M[-1,1]=1) and (Mire.M[0,1]=1)       // 001
                      and (Mire.M[1,-1]=1) and (Mire.M[1,0]=1) then // 011
                      begin case DP of                              // 110
                                 Station,Ouest : PS:=Sud;
                                 Nord          : PS:=Est;
                                 else sms('angle imprvu 23');
                            end;
                      end else
                      if (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1)       // 011
                      and (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) then // 110
                      begin case DP of                               // 100
                                 Station,Est : PS:=Nord;
                                 Sud         : PS:=Ouest;
                                 else sms('angle imprvu 24');
                            end;
                      end else
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)    // 100
                      and (Mire.M[0,1]=1) and (Mire.M[1,1]=1) then // 110
                      begin case DP of                             // 011
                                 Station,Est : PS:=Sud;
                                 Nord        : PS:=Ouest;
                                 else sms('angle imprvu 25');
                            end;
                      end else // Suite = Pour pointes d''angles <=36                   1
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)                   //  110
                      and (Mire.M[0,-1]=1) and (Mire.M[1,0]=1) then               // 1111
                      begin if CUnePointue(Ouest,Nord,bmp,xct,yct-1,pa1,pa2) then //  000
                            begin if Tour=2 then
                                  begin for xp:=xct downto pa2.x
                                        do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa2.x to pa1.x-1
                                        do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa1.x to xct
                                        do SauverPointTraj(xp,pa1.y,ind);
                                  end;
                                  yct:=pa1.y; PS:=NordEst;
                                  sms('CUnePointue A ');
                            end else sms('angle imprvu 26');
                      end else // Pour pointes d''angles
                      if (Mire.M[-1,0]=1) and (Mire.M[0,-1]=1)             // 011
                      and (Mire.M[1,-1]=1) and (Mire.M[1,0]=1) then        // 111
                      begin if CUnePointue(Est,Nord,bmp,xct,yct-1,pa1,pa2) then // 000
                            begin if Tour=2 then
                                  begin for xp:=xct to pa2.x
                                        do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa2.x downto pa1.x+1
                                        do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa1.x downto xct
                                        do SauverPointTraj(xp,pa1.y,ind);
                                  end;
                                  yct:=pa1.y; PS:=NordOuest;
                                  sms('CUnePointue B ');
                            end else sms('angle imprvu 27');
                      end else // Pour pointes d''angles
                      if (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1)                   // 000
                      and (Mire.M[0,1]=1) and (Mire.M[1,0]=1) then               // 111
                      begin if CUnePointue(Ouest,Sud,bmp,xct,yct+1,pa1,pa2) then // 110
                            begin if Tour=2 then
                                  begin for xp:=xct downto pa2.x
                                        do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa2.x to pa1.x-1
                                        do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa1.x to xct
                                        do SauverPointTraj(xp,pa1.y,ind);
                                  end;
                                  yct:=pa1.y; PS:=SudEst;
                                  sms('CUnePointue C ');
                            end else sms('angle imprvu 28');
                      end else // Pour pointes d''angle
                      if (Mire.M[-1,0]=1) and (Mire.M[0,1]=1)                  // 000
                      and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then             // 111
                      begin if CUnePointue(Est,Sud,bmp,xct,yct+1,pa1,pa2) then // 011
                            begin if Tour=2 then
                                  begin for xp:=xct to pa2.x
                                        do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa2.x downto pa1.x+1
                                        do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa1.x downto xct
                                        do SauverPointTraj(xp,pa1.y,ind);
                                  end;
                                  yct:=pa1.y; PS:=SudOuest;
                                  sms('CUnePointue D ');
                            end else sms('angle imprvu 29');
                      end else // Suite = Pour pointes d''angles
                      if (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1)                   // 010
                      and (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) then              // 110
                      begin if CUnePointue(Sud,Ouest,bmp,xct-1,yct,pa1,pa2) then // 110
                            begin if Tour=2 then
                                  begin for yp:=yct to pa2.y
                                        do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa2.y downto pa1.y+1
                                        do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa1.y downto yct
                                        do SauverPointTraj(pa1.x,yp,ind);
                                  end;
                                  xct:=pa1.x; PS:=NordOuest;
                                  sms('CUnePointue Art ');
                            end else sms('angle imprvu 30');
                      end else // Suite = Pour pointes d''angles
                      if (Mire.M[0,-1]=1) and (Mire.M[0,1]=1)                  // 010
                      and (Mire.M[1,0]=1) and (Mire.M[1,1]=1) then             // 011
                      begin if CUnePointue(Sud,Est,bmp,xct+1,yct,pa1,pa2) then // 011
                            begin if Tour=2 then
                                  begin for yp:=yct to pa2.y
                                        do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa2.y downto pa1.y+1
                                        do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa1.y downto yct
                                        do SauverPointTraj(pa1.x,yp,ind);
                                  end;
                                  xct:=pa1.x; PS:=NordEst;
                                  sms('CUnePointue Crt ');
                            end else sms('angle imprvu 31');
                      end else // Pour pointes d''angles
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1)                   // 110
                      and (Mire.M[0,-1]=1) and (Mire.M[0,1]=1) then               // 110
                      begin if CUnePointue(Nord,Ouest,bmp,xct-1,yct,pa1,pa2) then // 010
                            begin if Tour=2 then
                                  begin for yp:=yct downto pa2.y
                                        do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa2.y to pa1.y-1
                                        do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa1.y to yct
                                        do SauverPointTraj(pa1.x,yp,ind);
                                  end;
                                  xct:=pa1.x; PS:=SudOuest;
                                  sms('CUnePointue Brt ');
                            end else sms('angle imprvu 32');
                      end else // Pour pointes d''angle
                      if (Mire.M[0,-1]=1) and (Mire.M[0,1]=1)                   // 011
                      and (Mire.M[1,-1]=1) and (Mire.M[1,0]=1) then             // 011
                      begin if CUnePointue(Nord,Est,bmp,xct+1,yct,pa1,pa2) then // 010
                            begin if Tour=2 then
                                  begin for yp:=yct downto pa2.y
                                        do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa2.y downto pa1.y-1
                                        do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa1.y to yct
                                        do SauverPointTraj(pa1.x,yp,ind);
                                  end;
                                  xct:=pa1.x; PS:=SudEst;
                                  sms('CUnePointue Drt');
                            end else sms('angle imprvu 33');
                      end else
                      begin sms('autre cas Mire.S=5');
                                AffMire(Mire, xct,yct);
                                xExt2:=xct; yExt2:=yct; BreakBSKP:=True;// leurre prov
                      end;
                end else
                if Mire.S=6 then
                begin // cas 6 pixels groups  l''Ouest :
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) // 110
                      and (Mire.M[-1,1]=1) and (Mire.M[0,-1]=1) // 110
                      and (Mire.M[0,1]=1) then                  // 110
                      begin case DP of
                                 Station,Sud,SudEst,Est : PS:=Sud;
                                 Nord,NordEst           : PS:=Nord;
                                 else sms('imprvu 6.1');
                            end;
                      end else // cas 6 pixels  l''Est :
                      if (Mire.M[0,-1]=1) and (Mire.M[0,1]=1)  // 011
                      and (Mire.M[1,-1]=1) and (Mire.M[1,0]=1) // 011
                      and (Mire.M[1,1]=1) then                 // 011
                      begin case DP of
                                 Station,Sud,SudOuest,Ouest : PS:=Sud;
                                 Nord,NordOuest             : PS:=Nord;
                                 else sms('imprvu 6.2');
                            end;
                      end else // cas 6 pixels au Nord :
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) // 111
                      and (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) // 111
                      and (Mire.M[1,0]=1) then                  // 000
                      begin case DP of
                                 Station,Sud,SudEst,Est : PS:=Est;
                                 SudOuest,Ouest         : PS:=Ouest;
                                 else sms('imprvu 6.3');
                            end;
                      end else // cas 6 pixels au Sud :
                      if (Mire.M[-1,0]=1) and (Mire.M[-1,1]=1) // 000
                      and (Mire.M[0,1]=1) and (Mire.M[1,0]=1)  // 111
                      and (Mire.M[1,1]=1) then                 // 111
                      begin case DP of
                                 Station,Nord,NordEst,Est : PS:=Est;
                                 NordOuest,Ouest         : PS:=Ouest;
                                 else sms('imprvu 6.4');
                            end;
                      end else // Pour pointes d''angles <=36
                      if (Mire.M[-1,1]=1) and (Mire.M[-1,0]=1) // 001
                      and (Mire.M[0,1]=1) and (Mire.M[1,-1]=1) // 110
                      and (Mire.M[1,1]=1) then                 // 111
                      begin if (DP=SudOuest) and CUnePointue(Ouest,Nord,bmp,xct,yct,pa1,pa2) then
                            begin if Tour=2 then
                                  begin for xp:=xct downto pa1.x
                                         do SauverPointTraj(xp,pa1.y,ind);
                                        for xp:=pa1.x-1 downto pa2.x
                                         do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa2.x to xct
                                         do SauverPointTraj(xp,pa2.y,ind);
                                  end;
                                  yct:=pa2.y; PS:=Est;
                                  sms('CUnePointue A ');
                            end else sms('angle imprvu 6.5');
                      end else // Pour pointes d''angles <=36
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,1]=1) // 100
                      and (Mire.M[0,1]=1) and (Mire.M[1,0]=1)   // 011
                      and (Mire.M[1,1]=1) then                  // 111
                      begin if (Dp=SudEst) and CUnePointue(Est,Nord,bmp,xct,yct,pa1,pa2) then
                            begin if Tour=2 then
                                  begin for xp:=xct to pa1.x
                                         do SauverPointTraj(xp,pa1.y,ind);
                                        for xp:=pa1.x+1 to pa2.x
                                         do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa2.x downto xct
                                         do SauverPointTraj(xp,pa2.y,ind);
                                  end;
                                  yct:=pa2.y; PS:=Ouest;
                                  sms('CUnePointue B ');
                            end else sms('angle imprvu 6.6');
                      end else // Pour pointes d''angles
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) // 111
                      and (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) // 110
                      and (Mire.M[1,1]=1) then                  // 001
                      begin if (DP=NordOuest) and CUnePointue(Ouest,Sud,bmp,xct,yct,pa1,pa2) then
                            begin if Tour=2 then
                                  begin for xp:=xct downto pa1.x
                                         do SauverPointTraj(xp,pa1.y,ind);
                                        for xp:=pa1.x-1 downto pa2.x
                                         do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa2.x to xct
                                         do SauverPointTraj(xp,pa2.y,ind);
                                  end;
                                  yct:=pa2.y; PS:=Est;
                                  sms('CUnePointue C ');
                            end else sms('angle imprvu 6.7');
                      end else // Pour pointes d''angles
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,1]=1) // 111
                      and (Mire.M[0,-1]=1) and (Mire.M[1,-1]=1) // 011
                      and (Mire.M[1,0]=1) then                  // 100
                      begin if (DP=NordEst) and CUnePointue(Est,Sud,bmp,xct,yct,pa1,pa2) then
                            begin if Tour=2 then
                                  begin for xp:=xct to pa1.x
                                         do SauverPointTraj(xp,pa1.y,ind);
                                        for xp:=pa1.x+1 to pa2.x
                                          do SauverPointTraj(xp,pa2.y,ind);
                                        for xp:=pa2.x downto xct
                                         do SauverPointTraj(xp,pa2.y,ind);
                                  end;
                                  yct:=pa2.y; PS:=Ouest;
                                  sms('CUnePointue D');
                            end else sms('angle imprvu 6.8');
                      end else // Pour angles pointus
                      if (Mire.M[-1,-1]=1) and (Mire.M[0,1]=1) // 101
                      and (Mire.M[1,-1]=1) and (Mire.M[1,0]=1) // 011
                      and (Mire.M[1,1]=1) then                 // 011
                      begin if (DP=SudEst) and CUnePointue(Sud,Ouest,bmp,xct,yct,pa1,pa2) then
                            begin if Tour=2 then
                                  begin for yp:=yct to pa1.y
                                         do SauverPointTraj(pa1.x,yp,ind);
                                        for yp:=pa1.y+1 to pa2.y
                                         do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa2.y downto yct
                                         do SauverPointTraj(pa2.x,yp,ind);
                                  end;
                                  xct:=pa2.x; PS:=Nord;
                                  sms('CUnePointue Art ');
                            end else sms('angle imprvu 6.9');
                      end else // Pour pointes d''angles
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) // 101
                      and (Mire.M[-1,1]=1) and (Mire.M[0,1]=1)  // 110
                      and (Mire.M[1,-1]=1) then                 // 110
                      begin if (DP=SudOuest) and CUnePointue(Sud,Est,bmp,xct,yct,pa1,pa2) then
                            begin if Tour=2 then
                                  begin for yp:=yct to pa1.y
                                         do SauverPointTraj(pa1.x,yp,ind);
                                        for yp:=pa1.y+1 to pa2.y
                                         do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa2.y downto yct
                                         do SauverPointTraj(pa2.x,yp,ind);
                                  end;
                                  xct:=pa2.x; PS:=Nord;
                                  sms('CUnePointue Crt ');
                            end else sms('angle imprvu 6.10');
                      end else // Pour pointes d''angle
                      if (Mire.M[-1,1]=1) and (Mire.M[0,-1]=1) // 011
                      and (Mire.M[1,-1]=1) and (Mire.M[1,0]=1) // 011
                      and (Mire.M[1,1]=1) then                 // 101
                      begin if (Dp=NordEst) and CUnePointue(Nord,Ouest,bmp,xct,yct,pa1,pa2) then
                            begin if Tour=2 then
                                  begin for yp:=yct downto pa1.y
                                         do SauverPointTraj(pa1.x,yp,ind);
                                        for yp:=pa1.y-1 downto pa2.y
                                         do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa2.y to yct
                                         do SauverPointTraj(pa2.x,yp,ind);
                                  end;
                                  xct:=pa2.x; PS:=Sud;
                                  sms('CUnePointue Brt ');
                            end else sms('angle imprvu 6.11');
                      end else // Pour pointes d''angle
                      if (Mire.M[-1,-1]=1) and (Mire.M[-1,0]=1) // 110
                      and (Mire.M[-1,1]=1) and (Mire.M[0,-1]=1) // 110
                      and (Mire.M[1,1]=1) then                  // 101
                      begin if (Dp=NordOuest) and CUnePointue(Nord,Est,bmp,xct,yct,pa1,pa2) then
                            begin if Tour=2 then
                                  begin for yp:=yct downto pa1.y
                                         do SauverPointTraj(pa1.x,yp,ind);
                                        for yp:=pa1.y-1 downto pa2.y
                                         do SauverPointTraj(pa2.x,yp,ind);
                                        for yp:=pa2.y to yct
                                         do SauverPointTraj(pa2.x,yp,ind);
                                  end;
                                  xct:=pa2.x; PS:=Sud;
                                  sms('CUnePointue Drt');
                            end else sms('angle imprvu 6.12');
                      end else
                      begin sms('autre cas Mire.S>=6');
                            AffMire(Mire, xct,yct);
                      end;
                end; // if Mire.S=X
                /////////
                if Not breakBSKP then
                begin ADP:=DP;
                      AllerEn(PS,xct,yct); //< La Mire est dplace d'un pas
                      Mire:=LisScanlinesVersMire(bmp,xct,yct);
                      //Mire:=LisPixelsVersMire(bmp,xct,yct);
                end else Break;
                /////////
                if (xct=xct0) and (yct=yct0) then // Rcup coo Deb de traj + Break
                begin if (Tour=2) and (not redep) // Pour Traj en circuit ferm
                      then begin xExt1:=xct; yExt1:=yct;
                                 AffInfos('Traj en circuit ferm'); end;
                       // Pour autres Traj xExt1,yExt1 etc rcuprs ailleurs
                      //sms('(xct=xct0) et (yct=yct0)');
                      if (not redep) then Break;
                end;
                if (Mire.S=2) then
                begin if Tour=1 then
                      begin {sms( 'Mire.S=2 1er tour : break'+crlf
                                +'xct='+intToStr(xct)+crlf
                                +'yct='+intToStr(yct)+crlf
                                +'xExt1='+intToStr(xExt1)+crlf
                                +'yExt1='+intToStr(yExt1)+crlf
                                +'xExt2='+intToStr(xExt2)+crlf
                                +'yExt2='+intToStr(yExt2));
                                AffMire(Mire,xct,yct);  }
                      end;
                      Break;
                end;
          end; // while (Mire.M[0,0]=1)
        Saut:
          //sms(intToStr(Tour));
       end; // For Tour:=1 to 2
       // Rcup point final trajectoire
       xExt2:=xct; yExt2:=yct;
       If (Not BreakBSKP) then SauverPointTraj(xExt2,yExt2,ind);
       TCount:=ind+1;
       Result:=True;
       ActuMireEtCooEcran(xct,yct);
       with F_Contour do
       begin labNBPoints.caption:='Nb Points : '+intToStr(TCount);
             labxE1.caption:='xExt1 = '+intToStr(xExt1);
             labyE1.caption:='yExt1 = '+intToStr(yExt1);
             labXE2.caption:='xExt2 = '+intToStr(xExt2);
             labYE2.caption:='yExt2 = '+intToStr(yExt2);
       end;
end; // RecoTrajectoire
{ =========================================================================== }
procedure TraceTrajControle(var Img : TImage; Traj : TTraj; Coul : TColor);
var       i,x,y,code,ms : integer;
begin     for i:=0 to TCount-1 do
          begin x:=Traj[i].x; y:=Traj[i].y;
                Img.canvas.Pixels[x,y]:=Coul;
                // Affichage au ralenti pour une vrif visuelle
                // de la continuit de la numrisation
                if F_Contour.checkBoxRalenti.checked then
                begin Img.Update; val(F_Contour.editRalenti.text,ms,code);
                      sleep(ms);
                end;
          end;
end;
{ =========================================================================== }
function clEnString(cl : TColor) : string;
var      R,G,B : byte;
begin    Result :=ColorToString(cl);
         if pos('$',Result)=1 then
         begin R:=getRValue(cl); G:=getGValue(cl); B:=getBValue(cl);
               Result:= 'R='+intToStr(R)+crlf+
                        'G='+intToStr(G)+crlf+
                        'B='+intToStr(B);
         end;
end;
{ =========================================================================== }
procedure TF_Contour.btnChargerBMPClick(Sender: TObject);
const     filtre='fichiers (*.bmp)|*.bmp|tous (*.*)|*.*';
var       perimetre : integer;
begin     openDialog1.title:=' Slectionner fichier trajectoire';
          openDialog1.initialDir:=ExtractFilePath(Application.ExeName);
          openDialog1.filter:=filtre;
          openDialog1.DefaultExt:='bmp';
          if openDialog1.execute then
          begin image1.picture.bitmap.LoadFromFile(OpenDialog1.fileName);
                Image1.Picture.Bitmap.PixelFormat := pf24bit; // pour ScanLine
                if Assigned(BMPSource) then BMPSource:=nil;
                BMPSource:=tBitMap.create;
                BMPSource:=image1.picture.bitmap;
                perimetre:=2*(BMPSource.Width + BMPSource.Height);
                SetLength(Traj,perimetre);
                TCount := 0 ;
                RazLabel ;
                //BmpPresent:=true;
          end;
end;
{ =========================================================================== }
procedure TF_Contour.btnExemplesClick(Sender: TObject);
//        Page d''accueil pour dmo avec exemples
var       w,h,perimetre,xo,yo,x,y,dy,dx,i,xc,yc : integer; AP : array of TPoint;
          a,b,c,d,e,f,g : integer; kd,ka,ro,theta : Extended;
begin     w:=F_Contour.clientWidth-left; h:=F_Contour.ClientHeight-top;
          with image1 do begin Width:=w; Height:=h; end;
          if Assigned(BMPSource) then BMPSource:=nil;
          BMPSource:=tBitMap.create;
          with BMPSource do
          begin PixelFormat:=pf24bit;
                Width:=w; Height:=h; perimetre:=2*(w + h);
                SetLength(Traj,2*perimetre);
          end;
          xo:=30; yo:=30;
          with BMPSource.Canvas do
          begin brush.color:=clBlack;
                Fillrect(Rect(0,0,image1.width, image1.height));
                Font.color:=clYellow;
                Font.Name:='Impact'; Font.size:=12;
                y:=yo; x:=xo+100;
                TextOut(x,y,'RECONNAISSANCE DE TRAJECTOIRES SUR *.bmp');
                Font.Name:='Arial'; Font.size:=8;
                Font.style:=[fsBold];
                x:=xo; y:=yo+50; dy:=textHeight('C')+4; dx:=textWidth('1) ');
                TextOut(x,y,'1) Dessiner un contour  l''aide du bouton droit de la souris');
                inc(y,dy);
                TextOut(x,y,'   ou bien charger un fichier de trajectoire(s) *.bmp');
                inc(y,dy);
                TextOut(x,y,'2) Cliquer sur une trajectoire pour la numriser');
                Font.color:=clAqua; Font.style:=[];
                inc(y,dy);
                TextOut(x,y,'Cette numrisation s''achve par un ');
                Font.color:=clLime;
                TextOut(x+175,y,'trac de contrle en Vert-citron');
                Font.color:=clAqua;
                TextOut(xo+330,y,' qui ne doit laisser subsister aucun point de couleur identique  celle du trac initial de la trajectoire.');
                inc(y,dy);
                // EXEMPLES de trajectoires :
                pen.width:=1; pen.Style:=psSolid;
                xo:=30; yo:=160; Font.color:=clYellow; Font.style:=[fsBold];
                textOut(xo,yo,'Exemples de Trajectoires :');
                Font.style:=[];
                textOut(xo+150,yo,'Cliquer');
                Font.Name:='Small Fonts'; Font.size:=7;
                // Trajectoire sinusodale sur porteuse incline :
                xo:=30; yo:=220;
                pen.color:=clYellow;
                MoveTo(xo,yo+20);
                for x:=xo to xo+150 do
                begin y:=round(yo + 20 - (x-xo)/5 +20*sin((x-xo)/5)); LineTo(x,y); end;
                // Trajectoire en ellipse :
                Ellipse(xo+170,yo-20,xo+270,yo+20);
                // Trajectoire en rectangle inclin  30 :
                x:=xo+290; y:=yo;  
                Polyline( [Point(x,y), Point(x+25,y+42), Point(x+93,y+2),
                          Point(x+68,y-40), Point(x,y) ]);
                // Trajectoire Bezier :
                PolyBezier([ Point(xo+405, yo-30),    Point(xo+505, yo-30),
                             Point(xo+355, yo+30), Point(xo+505, yo+30) ]);
                // Trajectoire Points Cardinaux :
                x:=xo+550; y:=yo; // centre
                a:=3; b:=18; c:=29; d:=11; e:=13; f:=19; g:=23; h:=7;
                Polyline( [Point(x-c,y-c), Point(x-c,y-e),  Point(x-g,y-f), //2
                           Point(x-h,y-a), Point(x-b,y-a),  Point(x-b,y-d), //5
                           Point(x-c,y),   Point(x-b,y+d),  Point(x-b,y+a), //8
                           Point(x-h,y+a), Point(x-g,y+f),  Point(x-c,y+e), //11
                           Point(x-c,y+c), Point(x-e,y+c),  Point(x-f,y+g), //14
                           Point(x-a,y+h), Point(x-a,y+b),  Point(x-d,y+b), //17
                           Point(x,y+c),   Point(x+d,y+b),  Point(x+a,y+b), //20
                           Point(x+a,y+h), Point(x+f,y+g),  Point(x+e,y+c), //23
                           Point(x+c,y+c), Point(x+c,y+e),  Point(x+g,y+f), //26
                           Point(x+h,y+a), Point(x+b,y+a),  Point(x+b,y+d), //29
                           Point(x+c,y),   Point(x+b,y-d),  Point(x+b,y-a), //32
                           Point(x+h,y-a), Point(x+g,y-f),  Point(x+c,y-e), //35
                           Point(x+c,y-c), Point(x+e,y-c),  Point(x+f,y-g), //38
                           Point(x+a,y-h), Point(x+a,y-b),  Point(x+d,y-b), //41
                           Point(x,y-c),   Point(x-d,y-b),  Point(x-a,y-b), //44
                           Point(x-a,y-h), Point(x-f,y-g),  Point(x-e,y-c), //47
                           Point(x-c,y-c) ]);
                // Trajectoire en zig-zag depuis bord :
                inc(yo,85); xo:=0;
                setLength(AP,11);
                Polyline( [Point(xo,yo),       Point(xo+20,yo),    Point(xo+35,yo-20),
                          Point(xo+50,yo-20),  Point(xo+85,yo+10), Point(xo+120,yo-30),
                          Point(xo+140,yo),    Point(xo+170,yo),   Point(xo+190,yo-15),
                          Point(xo+610,yo+15), Point(0,yo+15) ]);
                font.color:=clLime;
                textOut(xo+30,yo+30,'^ OK pour zig-zag avec pointes trs effiles si un des bords de la pointe est horizontal ou vertical ^');
                // Trajectoire  entrelacs :
                pen.color:=clYellow;
                setLength(AP,98);
                a:=20; kd:=0.6; ka:=sqrt(2)/2;
                a:=round(a*ka); b:=round(kd*a);
                //sms(intToStr(c));
                xo:=0; yo:=yo+80;
                moveTo(xo,yo); x:=xo+30; LineTo(x,yo);
                AP[0].x:=x;   AP[0].y:=yo;
                AP[1].x:=x+a; AP[1].y:=yo-a;
                AP[2].x:=AP[1].x+a; AP[2].y:=yo;
                AP[3].x:=AP[2].x-a; AP[3].y:=yo+a;
                AP[4].x:=AP[3].x-b; AP[4].y:=AP[3].y-b;
                c:=2*(AP[4].x-AP[0].x);
                for i:=5 to 97 do
                begin if ( ((i-1) mod 4)=0 ) then
                      begin AP[i].x:=AP[i-4].x+c; AP[i].y:=yo-a; end else
                      if ( ((i-2) mod 4)=0 ) then
                      begin AP[i].x:=AP[i-4].x+c; AP[i].y:=yo; end else
                      if ( ((i-3) mod 4)=0 ) then
                      begin AP[i].x:=AP[i-4].x+c; AP[i].y:=yo+a; end else
                      if ( ((i-4) mod 4)=0 ) then
                      begin AP[i].x:=AP[i-4].x+c; AP[i].y:=AP[i-4].y; end;
                end;
                Polyline(AP);
                font.color:=clLime;
                textOut(AP[97].x+10,yo-8,'<-- OK si croisements  90');
          end;
          //
          BMPSource.SaveToFile(ExtractFilePath(Application.ExeName)+'TrajExemples.bmp');
          //image1.Picture.LoadFromFile(ExtractFilePath(Application.ExeName)+'TrajExemples.bmp');
          image1.Picture.BitMap:=BMPSource;
          TCount := 0 ;
          RazLabel ;
end;
{ =========================================================================== }
procedure TF_Contour.EcranNoir ;
//        Page d''accueil vierge
var       w,h,perimetre,xo,yo,x,y,dy,dx : integer;
begin     w:=F_Contour.clientWidth-left; h:=F_Contour.ClientHeight-top;
          with image1 do begin Width:=w; Height:=h; end;
          if Assigned(BMPSource) then BMPSource:=nil;
          BMPSource:=tBitMap.create;
          with BMPSource do
          begin PixelFormat:=pf24bit;
                Width:=w; Height:=h; perimetre:=2*(w + h);
                SetLength(Traj,2*perimetre);
          end;
          xo:=30; yo:=30;
          with BMPSource.Canvas do
          begin brush.color:=clBlack;
                Fillrect(Rect(0,0,image1.width, image1.height));
                Font.color:=clYellow;
                Font.Name:='Impact'; Font.size:=12;
                y:=yo; x:=xo+100;
                TextOut(x,y,'RECONNAISSANCE DE TRAJECTOIRES SUR *.bmp');
                Font.Name:='Arial'; Font.size:=8;
                Font.style:=[fsBold];
                x:=xo; y:=yo+50; dy:=textHeight('C')+4; dx:=textWidth('1) ');
                TextOut(x,y,'1) Dessiner un contour  l''aide du bouton droit de la souris');
                inc(y,dy);
                TextOut(x,y,'   ou bien charger un fichier de trajectoire(s) *.bmp');
                inc(y,dy);
                TextOut(x,y,'2) Cliquer sur une trajectoire pour la numriser');
                Font.color:=clAqua; Font.style:=[];
                inc(y,dy);
                TextOut(x,y,'Cette numrisation s''achve par un ');
                Font.color:=clLime;
                TextOut(x+175,y,'trac de contrle en Vert-citron');
                Font.color:=clAqua;
                TextOut(xo+330,y,' qui ne doit laisser subsister aucun point de couleur identique');
                inc(y,dy);
                TextOut(x,y,' celle du trac initial de la trajectoire.');
          end;
          //
//          BMPSource.SaveToFile(ExtractFilePath(Application.ExeName)+'TrajExemples.bmp');
          //image1.Picture.LoadFromFile(ExtractFilePath(Application.ExeName)+'TrajExemples.bmp');
          image1.Picture.BitMap:=BMPSource;
          TCount := 0 ;
          RazLabel ;
end;
{ =========================================================================== }
procedure TF_Contour.PointesDAnglesClick(Sender: TObject);
//        Planche de cas rsolus ou  dvelopper
var       w,h,perimetre,xo,yo,x,y,dy,xc,yc : integer; AP : array of TPoint;
          ad : Extended; s : string;
{ =========================================================================== }
          procedure TraceAngle(ADegres : Extended; var xg,yg : integer; Resolu : boolean );
          var       ARadians : Extended; lg : integer;
          begin     SetLength(AP,3); ARadians:=Pi*ADegres/180;
                    lg:=50; if Adegres<=1 then lg:=100;
                    with BMPSource.canvas do
                    begin pen.width:=1;
                          if Resolu then pen.color:=clYellow else pen.color:=clAqua;
                          font.name:='Small Fonts';
                          font.size:=7;
                          font.color:=clLime;
                          if ADegres<=90 then
                          begin AP[2].x:=xg+round(lg*cos(ARadians));
                                AP[2].y:=yg-round(lg*sin(ARadians));
                                AP[1].x:=xg;
                                AP[1].y:=yg;
                                AP[0].y:=yg;
                                AP[0].x:=AP[2].x+20; end else
                          begin AP[2].x:=xg;
                                AP[2].y:=yg-round(lg*sin(ARadians));
                                AP[1].x:=xg-round(lg*cos(ARadians));
                                AP[1].y:=yg;
                                AP[0].y:=yg;
                                AP[0].x:=AP[1].x+20;
                          end;
                          s:=FloatToStr(ADegres)+'';
                          textOut(AP[2].x+3,yg-14,s);
                          Polyline(AP);
                    end;
                    xg:=AP[2].x+35;
          end; // TraceAngle
{ =========================================================================== }
          procedure TraceAngleRota(AngDegres,ARotaDegres : Extended; var xg,yg : integer; Resolu : boolean );
          //        Pour AngDegres < 37  90
          var       AngRadians,ARotaRad : Extended; xmax,ymax,lg : integer;
          begin     SetLength(AP,3);
                    AngRadians:=Pi*AngDegres/180; ARotaRad:=Pi*ARotaDegres/180;
                    lg:=50; if AngDegres<=1 then lg:=100;
                    with BMPSource.canvas do
                    begin pen.width:=1;
                          if Resolu then pen.color:=clYellow else pen.color:=clAqua;
                          font.name:='Small Fonts';
                          font.size:=7;
                          font.color:=clLime;
                          AP[0].x:=xg; AP[0].y:=yg;
                          AP[1].x:=xg + round(lg*cos(ARotaRad));
                          AP[1].y:=yg - round(lg*sin(ARotaRad));
                          AP[2].x:=AP[1].x + round(lg*cos(ARotaRad + Pi - AngRadians));
                          AP[2].y:=AP[1].y - round(lg*sin(ARotaRad + Pi - AngRadians));
                          xmax:=0;
                          xmax:=max(xmax,AP[0].x); xmax:=max(xmax,AP[1].x);
                          xmax:=max(xmax,AP[2].x);
                          ymax:=0;
                          ymax:=max(ymax,AP[0].y); ymax:=max(ymax,AP[1].y);
                          ymax:=max(ymax,AP[2].y);
                          s:=FloatToStr(ARotaDegres)+'';
                          textOut(xmax+3,ymax-14,s);
                          Polyline(AP);
                    end;
                    xg:=xmax+35;
          end; // TraceAngleRota
{ ============================================================================= }

begin     w:=F_Contour.clientWidth-left; h:=F_Contour.ClientHeight-top;
          with image1 do begin Width:=w; Height:=h; end;
          if Assigned(BMPSource) then BMPSource:=nil;
          BMPSource:=tBitMap.create;
          with BMPSource do
          begin PixelFormat:=pf24bit;
                Width:=w; Height:=h; perimetre:=2*(w + h);
                SetLength(Traj,2*perimetre);
          end;
          xo:=30; yo:=20;
          with BMPSource.Canvas do
          begin brush.color:=clBlack;
                Fillrect(Rect(0,0,image1.width, image1.height));
                Font.name:='Arial';
                Font.style:=[fsBold]; Font.Size:=8;
                x:=xo; y:=yo; dy:=textHeight('C')+4;
                Font.color:=clYellow; TextOut(x,y,'Limites : Jaune = cas rsolus ');
                Font.color:=clAqua;   TextOut(x+170,y,'Bleu-clair = cas  dvelopper si besoin est');
                font.name:='Small Fonts'; font.size:=7; Font.color:=clLime;
                inc(y,dy);
                TextOut(x,y,'(Cas intermdiaires non reprsents. Cliquer sur un bord d''angle sauf sur l''extrmit des pointes )');
                inc(y,2*dy);
                Font.color:=clYellow; TextOut(x,y,'Pointes d''angles :');
                yo:=y+45; xo:=xo+10;
                TraceAngle(1,xo,yo, True); // Pointues A B C ...
                TraceAngle(2,xo,yo, True);
                TraceAngle(3,xo,yo, True);
                TraceAngle(35,xo,yo, True);
                TraceAngle(36,xo,yo, True);
                yo:=yo+60; xo:=40;
                TraceAngle(37,xo,yo, True);
                TraceAngle(38,xo,yo, True);
                TraceAngle(39,xo,yo, True);
                TraceAngle(40,xo,yo, True);
                TraceAngle(45,xo,yo, True);
                TraceAngle(89,xo,yo, True);
                TraceAngle(90,xo,yo, True);
                TraceAngle(91,xo,yo, True);
                TraceAngle(179,xo,yo, True);
                // Pointes d'angles orientes diversement
                xo:=30; inc(yo,20); ad:=60; // 60 ok
                Font.color:=clYellow;
                textOut(xo,yo,'Pointes orientes diversement si >= '+FloatToStr(ad)+' :');
                inc(yo,80);
                TraceAngleRota(ad,0, xo,yo, True);
                TraceAngleRota(ad,20, xo,yo, True);
                TraceAngleRota(ad,44, xo,yo, True);
                TraceAngleRota(ad,45, xo,yo, True);
                TraceAngleRota(ad,60, xo,yo, True);
                TraceAngleRota(ad,72, xo,yo, True);
                inc(xo,10);
                TraceAngleRota(ad,90, xo,yo, True);
                inc(xo,40);
                TraceAngleRota(ad,110, xo,yo, True);
                inc(xo,40);
                TraceAngleRota(ad,123, xo,yo, True); //123 ok mais 124 nok
                xo:=80; inc(yo,60);
                TraceAngleRota(ad,130, xo,yo, False);
                inc(xo,40);
                TraceAngleRota(ad,136, xo,yo, True); //136 ok mais 135 nok
                dec(yo,35);
                TraceAngleRota(ad,270, xo,yo, True);
                TraceAngleRota(ad,280, xo,yo, True);
                TraceAngleRota(ad,300, xo,yo, True);
                inc(yo,10);
                TraceAngleRota(ad,320, xo,yo, True);
                inc(yo,5);
                TraceAngleRota(ad,330, xo,yo, True);
                inc(yo,5);
                TraceAngleRota(ad,340, xo,yo, True);
                inc(yo,5);
                TraceAngleRota(ad,350, xo,yo, True);
                inc(yo,5);
                TraceAngleRota(ad,360, xo,yo, True);
                xo:=30; inc(yo,40);
                font.color:=clYellow;
                textOut(xo,yo,'Pointes effiles < 60 : Ok si un des bords est sur une verticale ou une horizontale');
                // Trajectoire avec angles aigus  pointe en angle droit sur 2x3 pixels
                // et avec croisement en agle droit sur 3x3 pixels :
                xo:=30; inc(yo,30);
                textOut(xo,yo,'Parade pour le cas de trajectoires avec angles ou croisements non dj rsolus : Prvoir');
                inc(yo,dy);
                textOut(xo,yo,'des pointes en angle droit sur 2x3 pixels, et des croisements en angle droit sur 3x3 pixels');
                pen.color:=clYellow;
                inc(xo); inc(yo,35);
                x:=xo; y:=yo;   moveTo(x,y);
                dec(x); dec(y); lineTo(x,y); //< pointe  angle droit
                inc(x); dec(y); lineTo(x,y);
                inc(x,100); dec(y,3); lineTo(x,y);
                inc(x,100); inc(y,3); lineTo(x,y);
                xc:=x+1; yc:=y+1; //< point de croisement
                inc(x,2); inc(y,2); lineTo(x,y); //< traverse du point de croisement
                inc(x,100); inc(y,23); lineTo(x,y); // point "bas" 2me moiti
                inc(x,100); dec(y,3);  lineTo(x,y);
                inc(x); dec(y); lineTo(x,y); //< 2ime pointe  angle droit
                dec(x); dec(y); lineTo(x,y);
                dec(x,100); dec(y,13); lineTo(x,y); // point "haut" 2me moiti
                x:=xc+1; y:=yc-1;      lineTo(x,y); // accrochage point haut croisement
                dec(x,2); inc(y,2);    lineTo(x,y); // traverse point de croisement
                dec(x,100); inc(y,3);  lineTo(x,y);
                lineTo(xo,yo); 
          end;
          BMPSource.SaveToFile(ExtractFilePath(Application.ExeName)+'TrajExemples.bmp');
          //image1.Picture.LoadFromFile(ExtractFilePath(Application.ExeName)+'TrajExemples.bmp');
          image1.Picture.BitMap:=BMPSource;
          RazLabel ;
          TCount := 0 ;
end;
{ =========================================================================== }
procedure TF_Contour.CroisementsClick(Sender: TObject);
//        Planche de cas rsolus ou  dvelopper
var       w,h,perimetre,xo,yo,x,y,dy,i,xc,yc : integer;
          Theta,ro : Extended; s : string;
{ =========================================================================== }
          procedure TraceCroisement(ADegres : Extended; var xg,yg : integer; Resolu : boolean );
          const     lg = 20;
          var       ARadians : Extended;
          begin     ARadians:=Pi*ADegres/180;
                    with BMPSource.canvas do
                    begin pen.width:=1;
                          if Resolu then pen.color:=clYellow else pen.color:=clAqua;
                          font.name:='Small Fonts';
                          font.size:=7;
                          font.color:=clLime;
                          moveTo(xg,yg); LineTo(xg+2*lg, yg);
                          moveTo(xg+round(lg*(1-cos(ARadians))),yg+round(lg*sin(ARadians)));
                          LineTo(xg+round(lg*(1+cos(ARadians))),yg-round(lg*sin(ARadians)));
                          s:=FloatToStr(ADegres)+'';
                          if ADegres < 90
                          then textOut(xg+round(lg*(1+cos(ARadians))),yg-12,s)
                          else textOut(xg+lg+3,yg-12,s)
                    end;
                    xg:=xg+2*lg+10;
          end; // TraceCroisement
{ --------------------------------------------------------------------- }
begin     w:=F_Contour.clientWidth-left; h:=F_Contour.ClientHeight-top;
          with image1 do begin Width:=w; Height:=h; end;
          if Assigned(BMPSource) then BMPSource:=nil;
          BMPSource:=tBitMap.create;
          with BMPSource do
          begin PixelFormat:=pf24bit;
                Width:=w; Height:=h; perimetre:=2*(w + h);
                SetLength(Traj,2*perimetre);
          end;
          xo:=30; yo:=20;
          with BMPSource.Canvas do
          begin brush.color:=clBlack;
                Fillrect(Rect(0,0,image1.width, image1.height));
                Font.name:='Arial';
                Font.style:=[fsBold]; Font.Size:=8;
                x:=xo; y:=yo; dy:=textHeight('C')+4;
                Font.color:=clYellow; TextOut(x,y,'Limites : Jaune = cas rsolus ');
                Font.color:=clAqua;   TextOut(x+170,y,'Bleu-clair = cas  dvelopper si besoin est');
                font.name:='Small Fonts'; font.size:=7; Font.color:=clLime;
                inc(y,dy);
                TextOut(x,y,'(cas intermdiaires non reprsents)');
                inc(y,2*dy);
                xo:=30; yo:=yo+60;
                Font.color:=clYellow; TextOut(xo,yo,'Croisements :');
                inc(yo,40); inc(xo,10);
                TraceCroisement(90,xo,yo,True);
                TraceCroisement(44,xo,yo,True);
                TraceCroisement(43,xo,yo,False);
                TraceCroisement(5,xo,yo,False);
                TraceCroisement(4,xo,yo,False);
                TraceCroisement(3,xo,yo,False);
                xo:=90; yo:=yo+60;
                TraceCroisement(136,xo,yo,True);
                TraceCroisement(137,xo,yo,False);
                TraceCroisement(175,xo,yo,False);
                TraceCroisement(176,xo,yo,False);
                TraceCroisement(177,xo,yo,False);
                // Trajectoire avec angles aigus  pointe en angle droit sur 2x3 pixels
                // et avec croisement en agle droit sur 3x3 pixels :
                xo:=30; inc(yo,50);
                Font.color:=clYellow;
                textOut(xo,yo,'Parade pour le cas de trajectoires avec angles ou croisements non dj rsolus : Prvoir');
                inc(yo,dy);
                textOut(xo,yo,'des pointes en angle droit sur 2x3 pixels, et des croisements en angle droit sur 3x3 pixels');
                pen.color:=clYellow;
                inc(xo); inc(yo,35);
                x:=xo; y:=yo;   moveTo(x,y);
                dec(x); dec(y); lineTo(x,y); //< pointe  angle droit
                inc(x); dec(y); lineTo(x,y);
                inc(x,100); dec(y,3); lineTo(x,y);
                inc(x,100); inc(y,3); lineTo(x,y);
                xc:=x+1; yc:=y+1; //< point de croisement
                inc(x,2); inc(y,2); lineTo(x,y); //< traverse du point de croisement
                inc(x,100); inc(y,23); lineTo(x,y); // point "bas" 2me moiti
                inc(x,100); dec(y,3);  lineTo(x,y);
                inc(x); dec(y); lineTo(x,y); //< 2ime pointe  angle droit
                dec(x); dec(y); lineTo(x,y);
                dec(x,100); dec(y,13); lineTo(x,y); // point "haut" 2me moiti
                x:=xc+1; y:=yc-1;      lineTo(x,y); // accrochage point haut croisement
                dec(x,2); inc(y,2);    lineTo(x,y); // traverse point de croisement
                dec(x,100); inc(y,3);  lineTo(x,y);
                lineTo(xo,yo);
                // Trajectoire trfle  3 feuilles simplifie
                xo:=70; yo:=y+70; pen.color:=clYellow;
                for i:=0 to 360 do
                begin Theta:=Pi*i/180;
                      ro:=50*sin(3*Theta);
                      x:=xo+round(ro*cos(Theta)); y:=yo+round(ro*sin(Theta));
                      if i=0 then MoveTo(x,y)
                      else LineTo(x,y);
                end;
                // Trajectoire trfle  4 feuilles simplifi
                xo:=170; dec(yo,10); pen.color:=clAqua;
                for i:=0 to 360 do
                begin Theta:=Pi*i/180;
                      ro:=50*sin(2*Theta);  //4 feuilles simplifi
                      //ro:=50*sin(0.25*Theta); // spirale
                      //ro:=50*sin(0.44*Theta); // sorte de G
                      x:=xo+round(ro*cos(Theta)); y:=yo+round(ro*sin(Theta));
                      if i=0 then MoveTo(x,y)
                      else LineTo(x,y);
                end;
                //Coeur de Raphal Laporte x = sinusCube(t) et y:=cos(t) - cosPuissance4(t)
                xo:=270; pen.color:=clYellow;
                for i:=0 to 360 do
                begin Theta:=Pi*i/180;
                      x:=xo+round(40*sin(Theta)*sin(Theta)*sin(Theta));
                      y:=yo-round(40*(cos(Theta) - cos(Theta)*cos(Theta)*cos(Theta)*cos(Theta)));
                      if i=0 then MoveTo(x,y)
                      else LineTo(x,y);
                end;
                //Bouche : x:= a*cos(t) et y:=a*sinCube(t);
                xo:=370; inc(yo,20); pen.color:=clYellow;
                for i:=0 to 360 do
                begin Theta:=Pi*i/180;
                      x:=xo+round(30*cos(Theta));
                      y:=yo-round(30*sin(Theta)*sin(Theta)*sin(Theta));
                      if i=0 then MoveTo(x,y)
                      else LineTo(x,y);
                end;
                // Trajectoire trfle  n=3 ou 4 quatre feuilles de Habenicht :
                xo:=530; inc(yo,50); pen.color:=clAqua;
                for i:=0 to 360 do
                begin Theta:=Pi*i/180;
                      ro:=40*(1 + cos(4*Theta) + sin(4*Theta)*sin(4*Theta));
                      x:=xo+round(ro*cos(Theta)); y:=yo+round(ro*sin(Theta));
                      if i=0 then MoveTo(x,y)
                      else LineTo(x,y);
                end;
              {  // Trajectoire Etoile  5 branches :
                pen.color:=clAqua;
                xo:=380; dec(yo,50);
                Polyline( [Point(xo+40,yo+10), Point(xo+20,yo+60), Point(xo+70,yo+30),
                          Point(xo+10, yo+30), Point(xo+60,yo+60), Point(xo+40,yo+10)]);
                }
          end;
          BMPSource.SaveToFile(ExtractFilePath(Application.ExeName)+'TrajExemples.bmp');
          //image1.Picture.LoadFromFile(ExtractFilePath(Application.ExeName)+'TrajExemples.bmp');
          image1.Picture.BitMap:=BMPSource;
          RazLabel ;
          TCount := 0 ;
end;
{ =========================================================================== }
procedure TF_Contour.FormShow(Sender: TObject);
begin
          Test := False ;
          ChkTest.Checked := Test ;
          ImpID := 0 ;
          labCoor.Transparent:=true;  // Pour l'Inspecteur d'Objets
          labCoor.font.color:=clAqua;
          labCoor.caption:='';
          labInfos.caption:='*';
          windowState:=wsMaximized;
          image1.AutoSize:=False;
          KeyPreview:=True;
          DoubleBuffered:=true;
          editRalenti.enabled:=False;
{          with image1 do
            Begin
              Width:=F_Contour.clientWidth-left;
              Height:=F_Contour.ClientHeight-top- Panel2.Height ;
            End;    }
          clTraj1:=clYellow;
          clTraj2:=clLime;
          RecoEnCours:=False;
          TCount := 0 ;
          EcranNoir ;
          RazLabel ;
          Painting := False ;
          Gomme := False ;
          
//          btnExemplesClick(Sender);
end;
{ =========================================================================== }
procedure TF_Contour.editXKeyPress(Sender: TObject; var Key: Char);
begin     if not (key in ['0'..'9','-',Chr(VK_Delete), Chr(VK_Back)]) then Key:=#0; end;
{ =========================================================================== }
procedure TF_Contour.editXChange(Sender: TObject);
var       x,y,code : integer;
begin     val(editX.text,x,code);
          val(editY.text,y,code);
          //if (Mouse.CursorPos.X<>x) or (Mouse.CursorPos.Y<>y) then SetCursorPos(x,y);
          ActuMireEcran(x,y);
end;
{ =========================================================================== }
procedure TF_Contour.editYChange(Sender: TObject);
var       x,y,code : integer;
begin     val(editX.text,x,code);
          val(editY.text,y,code);
          ActuMireEcran(x,y);
end;
var       clPipette : TColor;
{ =========================================================================== }
procedure TF_Contour.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
var       co,li : integer; scl : string; ok : boolean;
begin
          if ssRight in shift then
            Begin
              Image1.Picture.Bitmap.Canvas .LineTo(x,y);
              Exit ;
            End ;
          if RecoEnCours then EXIT;
          with labCoor do // Affichage coordonnes souris + couleur Pixel dans Sprite-labCoor
          begin if X+80 > Image1.left+Image1.width
                then Left:=Image1.left+X-40
                else Left:=X+20+Image1.left;
                if Y+30 > Image1.top+Image1.height
                then Top:=Y+Image1.Top-30
                else Top:=Y+Image1.Top;
                // Pipette 9 cases (pour faciliter l'agrippage de la trajectoire) :
                clPipette:=clBlack;
                MireCL:=LisScanlinesVersMireCL(Image1.Picture.Bitmap, X,Y);
                co:=-2; li:=-2; ok:=false;
                repeat inc(co);
                       repeat inc(li);
                              if MireCl[co,li]<>clBlack then
                              begin clPipette:=MireCl[co,li]; ok:=true; end;
                       until (li=1) or ok;
                       li:=-2;
                until (co=1) or ok;
                if ok then font.color:=clPipette
                      else font.color:=clAqua;
                {Pipette simple : ( gnante : faut viser pile sur un pixel de la traj)
                clPipette:=LisScanlinePixel(Image1.Picture.Bitmap, X,Y);
                if clPipette<>clBlack
                then font.color:=clPipette else font.color:=clAqua; }
                scl:=clEnString(clPipette);
                caption:='x='+intToStr(X)+crlf+'y='+intToStr(Y)+crlf+scl;
                upDate;
          end;
          ActuMireEtCooEcran(X,Y);
end;
{ =========================================================================== }
procedure TF_Contour.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var       Start : DWord;
          Perimetre : Integer ;
begin
          If Painting Then
          Begin
            Painting := False ;
            Image1.Picture.Bitmap.PixelFormat := pf24bit; // pour ScanLine
            if Assigned(BMPSource) then BMPSource:=nil;
            BMPSource:=tBitMap.create;
            BMPSource:=image1.picture.bitmap;
            perimetre:=2*(BMPSource.Width + BMPSource.Height);
            SetLength(Traj,perimetre);
            TCount := 0 ;
            RazLabel ;
          End ;
          if RecoEnCours  then EXIT;
          if clPipette<>clBlack then
          begin clTraj1:=clPipette;
                xExt1:=X; yExt1:=Y;
                RecoEnCours:=True; Start :=GetTickCount;
                LTraj := 0 ;
                Memo1.Clear ;
                F_Contour.Memo1.lines.add('Trajectoire :') ;
                F_Contour.Memo1.lines.add('n  X   Y' );
                if RecoTrajectoire(BMPSource,xExt1,yExt1) then
                begin TraceTrajControle(Image1,Traj,clLime);
                      labChrono.caption:='mis : '+intToStr(GetTickCount-Start)+' ms';
                end else labInfos.caption:='';
                Surf := 0 ;
                kDeb := 0 ;
                Surface(kDeb, Surf) ;
                Perimetre2(KDeb, Perim) ;
                LblPoint0.caption  := 'Point : '+intToStr(KDeb);
                LblPointN.caption  := ' : '+intToStr(TCount-1);
                LblSurface.caption := Format('Surface : %8.2f',[Surf]) ;
                LblPerimetre.caption := Format('Primtre : %8.2f',[Perim]) ;
                RecoEnCours:=False;
          end;
end;
{ =========================================================================== }
procedure TF_Contour.FormKeyPress(Sender: TObject; var Key: Char);
//        Utilis lors de tests :  virer par la suite
var       co,li : integer;
begin     if key='c' then
          begin MireCL:=LisScanlinesVersMireCL( Image1.Picture.Bitmap,
                                                Mouse.CursorPos.X,Mouse.CursorPos.Y);
                co:=-2;
                repeat inc(co); li:=-2;
                       repeat inc(li);
                              sms( 'mireCL '+crlf+
                                   'co='+intToStr(co)+crlf+
                                   'li='+intToStr(li)+crlf+
                                   clEnString(MireCL[co,li]));
                       until li=1;
                until co=1;
          end;
end;
{ =========================================================================== }
procedure TF_Contour.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var       x,y,code : integer;
begin     val(editX.text,x,code); val(editY.text,y,code);
          case key of
               VK_LEFT  : dec(x);
               VK_UP	: dec(y);
               VK_RIGHT	: inc(x);
               VK_DOWN  : inc(y);
          end;
          ActuMireEtCooEcran(X,Y);
end;
{ =========================================================================== }
procedure TF_Contour.CheckBoxRalentiClick(Sender: TObject);
begin     editRalenti.enabled:=CheckBoxRalenti.Checked;
end;
{ =========================================================================== }
procedure TF_Contour.btnCasClick(Sender: TObject);
var       p : tPoint;
begin     p.x:=btnCas.left;
          p.y:=btnCas.Top;
          p:=clientToScreen(p);
          popUpCasLimites.Popup(p.x,p.y);
end;
{ =========================================================================== }
procedure TF_Contour.BtnSauveClick(Sender: TObject);
Var
  Fichier : String ;
begin
  If (TCount > 0) Then
    Begin
      Fichier := 'Trajectoire.txt' ;
      Memo1.Lines.SaveToFile(Fichier) ;
      ImpId := LanceNotePad(Fichier) ;
    End
  Else
    MessageDlg('Pas de trajectoire  afficher' , mtWarning, [mbOk], 0) ;
end;


{ ====================================================================== }
Function TF_Contour.LanceNotePad(Fichier : String): dword;
// Lancement de Notepad avec CreateProcess
//  renvoie le Handle du process
//  il faut ajouter la dclaration :
//      function GetThreadId(Thread: THandle): dword; stdcall; external 'Kernel32.dll';

var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  CommandLine: {$IFDEF UNICODE}WideString{$ELSE}string{$ENDIF};
Begin
  Result := 0 ;
  If not FileExists(Fichier) Then
    Begin
      MessageDlg('Fichier '+Fichier+' introuvable' , mtError, [mbOk], 0) ;
      Exit ;
    End ;
  CommandLine := '"Notepad.exe" "'+Fichier+'"' ;
  ZeroMemory(@StartupInfo, SizeOf(StartupInfo)) ;
  StartupInfo.cb := SizeOf(StartupInfo) ;
  if CreateProcess(nil, PChar(CommandLine), nil, nil, FALSE, 0, nil, nil, StartupInfo, ProcessInfo) then
    Begin
      Result := GetThreadID(ProcessInfo.hThread);
      CloseHandle(ProcessInfo.hProcess);
      CloseHandle(ProcessInfo.hThread);
    End;
End ;
{ ====================================================================== }
Function TF_Contour.FermeNotePad(ImpID : dWord ) : Boolean ;
// Fermeture du Process ImpID (par exemple Notepad
//  Lanc par LanceNotePad
Begin
//  ImpID := LanceNotePad(FicImp);
//  ShowMessage('Notepad ouvert') ;
  Result := PostThreadMessage(ImpID, WM_QUIT, 0, 0);
End ;
{ ====================================================================== }
procedure TF_Contour.FormDestroy(Sender: TObject);
begin
  If (ImpID > 0) Then  FermeNotePad(ImpID) ;
end;
{ ====================================================================== }
Procedure TF_Contour.Surface(Var kDeb : Integer ; Var Surf : Extended);
// dtermination de KDeb dbut du contour
// Calcul de la surface de la trajectoire de Kdeb  TCount-1 + Fermeture
Var
  Dx     : Extended  ;
  i      : Integer ;
  Dist   : Real    ;   // Distance de 2 pts conscutifs
  SurfSup : Extended ;
begin
  Surf := 0 ;
  // Ellimination des points extrmes du premier tour
  kDeb := 0 ;   // nombre de points  enlever au dbur de Traj
  For i := 0 To TCount-2 do
    Begin
      Dist := sqrt(Sqr(Traj[i].X - Traj[i+1].X) + Sqr(Traj[i].Y - Traj[i+1].Y) ) ;
      If (Dist < 3) Then Break ;
      kDeb := kDeb + 1
    End ;
  LTraj := TCount - kDeb ;
  If (LTraj > 0) Then
    Begin
      Surf := 0 ;
      For i := kDeb To TCount-2 Do
        Begin
          Dx := Traj[i+1].X-Traj[i].X ;
          Surf := Surf + (Traj[i+1].Y+Traj[i].Y)*Dx/2 ;
        End ;
      // Fermeture du contour si besoin
      Dx := Traj[kDeb].X-Traj[TCount-1].X ;
      SurfSup :=  (Traj[kDeb].Y+Traj[TCount-1].Y)*Dx/2 ;
      Surf := Surf + SurfSup ;
      Surf := Abs(Surf) ;
    End ;
end;
{ ====================================================================== }
Procedure TF_Contour.Perimetre2(kDeb : Integer ; Var Perim : Extended);
// Calcul du primtre ou longueur de la trajectoire de Kdeb  TCount-1 + Fermeture
Var
  i      : Integer ;
  Dist   : Real    ;   // Distance de 2 pts conscutifs
  LTraj  : Integer ;
begin
  Perim := 0 ;
  LTraj := TCount - kDeb ;
  If (LTraj > 0) Then
    Begin
      Perim := 0 ;
      For i := kDeb To TCount-2 Do
        Begin
          Dist := sqrt(Sqr(Traj[i].X - Traj[i+1].X) + Sqr(Traj[i].Y - Traj[i+1].Y) ) ;
          Perim := Perim + Dist ;
        End ;
//      MessageDlg(Format('Longueur du contour : %8.2f',[Perim]) , mtinformation, [mbOk], 0) ;
    End ;
//  Else
//    MessageDlg('Pas de longueur de trajectoire  calculer' , mtWarning, [mbOk], 0) ;
end;
{ ====================================================================== }
procedure TF_Contour.BtnQuitterClick(Sender: TObject);
begin
  Close ;
end;
{ ====================================================================== }
Procedure TF_Contour.RazLabel ;
Begin
  LabNBPoints.caption  := 'Nb Points : ';
  LabXE1.caption  := 'xE1 : ';
  LabYE1.caption  := 'yE1 : ';
  LabXE2.caption  := 'xE2 : ';
  LabYE2.caption  := 'yE2 : ';
  LblPoint0.caption  := 'Point : ';
  LblPointN.caption  := ' : ';
  LblPerimetre.caption := 'Primtre : ' ;
  LblSurface.caption   := 'Surface : ' ;
End ;
{ ====================================================================== }
procedure TF_Contour.ChkTestClick(Sender: TObject);
// Mode test ou non
begin
  Test :=  ChkTest.Checked  ;
end;
{ ====================================================================== }
procedure TF_Contour.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If (ssRight in Shift) Then
    Begin
      Painting := True ;
      LabCoor.Caption := '' ;
      With Image1.Picture.Bitmap.Canvas do begin
        MoveTo(x,y);
        If Gomme Then
          Begin
          // Mode Gomme
            Pen.Color := clBlack;
            Pen.Width := 6;
          End
        Else
          Begin
          // Mode dessin de contour
            Pen.Color := clYellow;
            Pen.Width := 1;
          End ;
      end;
    End ;
end;
{ ====================================================================== }
procedure TF_Contour.Btn_GommeClick(Sender: TObject);
begin
  Gomme := Btn_Gomme.Down ;
end;
{ ====================================================================== }
end.
